Permalink
Switch branches/tags
Find file
Fetching contributors…
Cannot retrieve contributors at this time
3033 lines (2614 sloc) 87.7 KB
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META NAME="generator" CONTENT="http://txt2tags.org">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf-8">
<TITLE>QGIS</TITLE>
<!-- Included /home/fischer/src/qgis/doc/style.css -->
<STYLE TYPE="text/css">
body{ background: white;
color: black;
font-family: arial,sans-serif;
}
pre { margin-left: 2em;
border: 1;
padding: 4px;
background: #ececec; }
pre, code { font-family: monospace }
.overview{ font: 1.82em; font-weight: bold;}
h1{ background-color: #F6F6F6;
color: #8FB171;
font-size: large;
font-weight: bold;
font-family: luxi serif, georgia, times new roman, times, serif;
background: none;
padding: 0.75em 0 0;
margin: 0;
line-height: 1.1em;
border-bottom: 5px solid #DCEB5C;
}
h2{ background-color: #F6F6F6;
color: #8FB171;
font-size: large;
font-weight: normal;
font-family: luxi serif, georgia, times new roman, times, serif;
background: none;
padding: 0.75em 0 0;
margin: 0;
line-height: 1.1em;
}
h3{ background-color: #F6F6F6;
color: #729FCF;
font-family: luxi serif, georgia, times new roman, times, serif;
font-weight: bold;
font-size: medium;
}
h4{ background-color: #F6F6F6;
color: #729FCF;
font-family: luxi serif, georgia, times new roman, times, serif;
font-weight: normal;
font-size: medium;
}
h5{ background-color: #F6F6F6;
color: #729FCF;
font-family: luxi serif, georgia, times new roman, times, serif;
font-weight: bold;
font-size: small;
}
a{ color: #729FCF;
font-family: arial,sans-serif;
font-size: small;
}
label{ background-color: #FFFFCC;
border: 1px solid black;
margin: 1px;
padding: 0px 3px;
font-size: small;
}
</STYLE>
</HEAD>
<BODY>
<DIV CLASS="header" ID="header">
<H1>QGIS</H1>
<H2>Building QGIS from source - step by step</H2>
<H3>Saturday June 10, 2017</H3>
</DIV>
<DIV CLASS="body" ID="body">
<P>
Last Updated: Saturday June 10, 2017
Last Change : Saturday June 10, 2017
</P>
<DIV CLASS="toc">
<OL>
<LI><A HREF="#toc1">Introduction</A>
<LI><A HREF="#toc2">Overview</A>
<LI><A HREF="#toc3">Building on GNU/Linux</A>
<UL>
<LI><A HREF="#toc4">3.1. Building QGIS with Qt 5.x</A>
<LI><A HREF="#toc5">3.2. Prepare apt</A>
<LI><A HREF="#toc6">3.3. Install build dependencies</A>
<LI><A HREF="#toc7">3.4. Setup ccache (Optional)</A>
<LI><A HREF="#toc8">3.5. Prepare your development environment</A>
<LI><A HREF="#toc9">3.6. Check out the QGIS Source Code</A>
<LI><A HREF="#toc10">3.7. Starting the compile</A>
<LI><A HREF="#toc11">3.8. Building Debian packages</A>
<LI><A HREF="#toc12">3.9. On Fedora Linux</A>
</UL>
<LI><A HREF="#toc13">Building on Windows</A>
<UL>
<LI><A HREF="#toc14">4.1. Building with Microsoft Visual Studio</A>
<LI><A HREF="#toc15">4.2. Building using MinGW</A>
<LI><A HREF="#toc16">4.3. Creation of MSYS environment for compilation of QGIS</A>
</UL>
<LI><A HREF="#toc17">Building on MacOS X</A>
<UL>
<LI><A HREF="#toc18">5.1. Install Developer Tools</A>
<LI><A HREF="#toc19">5.2. Install Qt4 from disk image</A>
<LI><A HREF="#toc20">5.3. Install CMake for OSX</A>
<LI><A HREF="#toc21">5.4. Install development frameworks for QGIS dependencies</A>
<LI><A HREF="#toc22">5.5. API documentation</A>
<LI><A HREF="#toc23">5.6. QGIS source</A>
<LI><A HREF="#toc24">5.7. Configure the build</A>
<LI><A HREF="#toc25">5.8. Building</A>
<LI><A HREF="#toc26">5.9. Post-Install</A>
</UL>
<LI><A HREF="#toc27">Setting up the WCS test server on GNU/Linux</A>
<UL>
<LI><A HREF="#toc28">6.1. Preparation</A>
<LI><A HREF="#toc29">6.2. Setup mapserver</A>
<LI><A HREF="#toc30">6.3. Create a home page</A>
<LI><A HREF="#toc31">6.4. Now deploy it</A>
<LI><A HREF="#toc32">6.5. Debugging</A>
</UL>
<LI><A HREF="#toc33">Setting up a Jenkins Build Server</A>
<LI><A HREF="#toc34">Debug output and running tests</A>
<LI><A HREF="#toc35">Authors and Acknowledgments</A>
</OL>
</DIV>
<A NAME="toc1"></A>
<H1>1. Introduction</H1>
<P>
This document is the original installation guide of the described software
QGIS. The software and hardware descriptions named in this
document are in most cases registered trademarks and are therefore subject
to the legal requirements. QGIS is subject to the GNU General Public
License. Find more information on the QGIS Homepage:
<A HREF="http://qgis.org">http://qgis.org</A>
</P>
<P>
The details, that are given in this document have been written and verified
to the best of knowledge and responsibility of the editors. Nevertheless,
mistakes concerning the content are possible. Therefore, all data are not
liable to any duties or guarantees. The editors and publishers do not take
any responsibility or liability for failures and their consequences. You are
always welcome for indicating possible mistakes.
</P>
<P>
Because the code of QGIS evolves from release to release, These instructions are
regularly updated to match the corresponding release. Instructions for the current
master branch are available at
<A HREF="http://htmlpreview.github.io/?https://raw.github.com/qgis/QGIS/master/doc/INSTALL.html.">http://htmlpreview.github.io/?https://raw.github.com/qgis/QGIS/master/doc/INSTALL.html.</A>
If you wish to build another version of QGIS, ensure to checkout the appropriate
release branch.
</P>
<P>
Please visit <A HREF="http://qgis.org">http://qgis.org</A> for information on joining our mailing lists
and getting involved in the project further.
</P>
<P>
/!\ <B>Note to document writers:</B> Please use this document as the central
place for describing build procedures. Please do not remove this notice.
</P>
<P>
/!\ <B>Note to document writers:</B> This document is generated from
doc/INSTALL.t2t - if you need to edit this document, be sure to edit that
file rather than the generated INSTALL document found in the root of the
source directory.
</P>
<A NAME="toc2"></A>
<H1>2. Overview</H1>
<P>
QGIS, like a number of major projects (e.g., KDE 4.0), uses CMake
(<A HREF="http://www.cmake.org">http://www.cmake.org</A>) for building from source.
</P>
<P>
Following a summary of the required dependencies for building:
</P>
<P>
Required build tools:
</P>
<UL>
<LI>CMake &gt;= 2.8.6
<LI>Flex &gt;= 2.5.6
<LI>Bison &gt;= 2.4
</UL>
<P>
Required build dependencies:
</P>
<UL>
<LI>Qt &gt;= 5.3.0
<LI>Proj &gt;= 4.4.x
<LI>GEOS &gt;= 3.4
<LI>Sqlite3 &gt;= 3.0.0
<LI>SpatiaLite
<LI>libspatialindex
<LI>GDAL/OGR &gt;= 2.0
<LI>Qwt &gt;= 5.0 &amp; (&lt; 6.1 with internal QwtPolar)
<LI>expat &gt;= 1.95
<LI>QScintilla2
<LI>QCA
<LI>qtkeychain (&gt;= 0.5)
</UL>
<P>
Optional dependencies:
</P>
<UL>
<LI>for GRASS providers and plugin - GRASS &gt;= 6.0.0. QGIS may be compiled with GRASS 6 or GRASS 7.
It can also be compiled with both GRASS versions in a single build but only if QGIS
is not installed with rpath. The desired GRASS version is chosen on runtime by setting
LD_LIBRARY_PATH or PATH.
<LI>for georeferencer - GSL &gt;= 1.8
<LI>for postgis support - PostgreSQL &gt;= 8.0.x
<LI>for gps plugin - gpsbabel
<LI>for mapserver export and PyQGIS - Python &gt;= 3.3
<LI>for python support - SIP &gt;= 4.12, PyQt &gt;= 5.3 must match Qt version, Qscintilla2
<LI>for qgis mapserver - FastCGI
<LI>for oracle provider - Oracle OCI library
</UL>
<P>
Indirect dependencies:
</P>
<P>
Some proprietary formats (e.g., ECW and MrSid) supported by GDAL require
proprietary third party libraries. QGIS doesn't need any of those itself to
build, but will only support those formats if GDAL is built accordingly. Refer
to <A HREF="http://gdal.org/formats_list.html">http://gdal.org/formats_list.html</A> ff. for instructions how to include
those formats in GDAL.
</P>
<A NAME="toc3"></A>
<H1>3. Building on GNU/Linux</H1>
<A NAME="toc4"></A>
<H2>3.1. Building QGIS with Qt 5.x</H2>
<P>
<B>Requires:</B> Ubuntu / Debian derived distro
</P>
<P>
/!\ <B>Note:</B> Refer to the section Building Debian packages for building
debian packages. Unless you plan to develop on QGIS, that is probably the
easiest option to compile and install QGIS.
</P>
<P>
These notes are for Ubuntu - other versions and Debian derived distros may
require slight variations in package names.
</P>
<P>
These notes are for if you want to build QGIS from source. One of the major
aims here is to show how this can be done using binary packages for <B>*all*</B>
dependencies - building only the core QGIS stuff from source. I prefer this
approach because it means we can leave the business of managing system packages
to apt and only concern ourselves with coding QGIS!
</P>
<P>
This document assumes you have made a fresh install and have a 'clean' system.
These instructions should work fine if this is a system that has already been
in use for a while, you may need to just skip those steps which are irrelevant
to you.
</P>
<A NAME="toc5"></A>
<H2>3.2. Prepare apt</H2>
<P>
The packages QGIS depends on to build are available in the "universe" component
of Ubuntu. This is not activated by default, so you need to activate it:
</P>
<OL>
<LI>Edit your /etc/apt/sources.list file.
<LI>Uncomment all the lines starting with "deb"
</OL>
<P>
Also you will need to be running Ubuntu 'precise' or higher in order for
all dependencies to be met.
</P>
<P>
Now update your local sources database:
</P>
<div class="code"><PRE>
sudo apt-get update
</PRE></div>
<A NAME="toc6"></A>
<H2>3.3. Install build dependencies</H2>
<TABLE BORDER="1">
<TR>
<TH>Distribution</TH>
<TH>install command for packages</TH>
</TR>
<TR>
<TD>stretch</TD>
<TD><CODE>apt-get install bison ca-certificates cmake dh-python doxygen flex gdal-bin git graphviz grass-dev libexpat1-dev libfcgi-dev libgdal-dev libgeos-dev libgsl-dev libpq-dev libproj-dev libqca-qt5-2-dev libqca-qt5-2-plugins libqt5opengl5-dev libqt5scintilla2-dev libqt5sql5-sqlite libqt5svg5-dev libqt5webkit5-dev libqt5xmlpatterns5-dev libqwt-qt5-dev libspatialindex-dev libspatialite-dev libsqlite3-dev libsqlite3-mod-spatialite lighttpd locales ninja-build pkg-config poppler-utils pyqt5-dev pyqt5-dev-tools pyqt5.qsci-dev python3-all-dev python3-dev python3-future python3-gdal python3-mock python3-nose2 python3-psycopg2 python3-pyqt5 python3-pyqt5.qsci python3-pyqt5.qtsql python3-pyqt5.qtsvg python3-sip python3-sip-dev python3-termcolor python3-yaml qt5keychain-dev qtbase5-dev qtpositioning5-dev qtscript5-dev qttools5-dev qttools5-dev-tools spawn-fcgi txt2tags xauth xfonts-100dpi xfonts-75dpi xfonts-base xfonts-scalable xvfb cmake-curses-gui expect</CODE></TD>
</TR>
<TR>
<TD>xenial</TD>
<TD><CODE>apt-get install bison ca-certificates cmake dh-python doxygen flex gdal-bin git graphviz grass-dev libexpat1-dev libfcgi-dev libgdal-dev libgeos-dev libgsl-dev libpq-dev libproj-dev libqca-qt5-2-dev libqca-qt5-2-plugins libqt5opengl5-dev libqt5scintilla2-dev libqt5sql5-sqlite libqt5svg5-dev libqt5webkit5-dev libqt5xmlpatterns5-dev libqwt-qt5-dev libspatialindex-dev libspatialite-dev libsqlite3-dev libsqlite3-mod-spatialite lighttpd locales ninja-build pkg-config poppler-utils pyqt5-dev pyqt5-dev-tools pyqt5.qsci-dev python3-all-dev python3-dev python3-future python3-gdal python3-mock python3-nose2 python3-psycopg2 python3-pyqt5 python3-pyqt5.qsci python3-pyqt5.qtsql python3-pyqt5.qtsvg python3-sip python3-sip-dev python3-termcolor python3-yaml qt5keychain-dev qtbase5-dev qtpositioning5-dev qtscript5-dev qttools5-dev qttools5-dev-tools spawn-fcgi txt2tags xauth xfonts-100dpi xfonts-75dpi xfonts-base xfonts-scalable xvfb cmake-curses-gui expect</CODE></TD>
</TR>
<TR>
<TD>yakkety</TD>
<TD><CODE>apt-get install bison ca-certificates cmake dh-python doxygen flex gdal-bin git graphviz grass-dev libexpat1-dev libfcgi-dev libgdal-dev libgeos-dev libgsl-dev libpq-dev libproj-dev libqca-qt5-2-dev libqca-qt5-2-plugins libqt5opengl5-dev libqt5scintilla2-dev libqt5sql5-sqlite libqt5svg5-dev libqt5webkit5-dev libqt5xmlpatterns5-dev libqwt-qt5-dev libspatialindex-dev libspatialite-dev libsqlite3-dev libsqlite3-mod-spatialite lighttpd locales ninja-build pkg-config poppler-utils pyqt5-dev pyqt5-dev-tools pyqt5.qsci-dev python3-all-dev python3-dev python3-future python3-gdal python3-mock python3-nose2 python3-psycopg2 python3-pyqt5 python3-pyqt5.qsci python3-pyqt5.qtsql python3-pyqt5.qtsvg python3-sip python3-sip-dev python3-termcolor python3-yaml qt5keychain-dev qtbase5-dev qtpositioning5-dev qtscript5-dev qttools5-dev qttools5-dev-tools spawn-fcgi txt2tags xauth xfonts-100dpi xfonts-75dpi xfonts-base xfonts-scalable xvfb cmake-curses-gui expect</CODE></TD>
</TR>
<TR>
<TD>zesty</TD>
<TD><CODE>apt-get install bison ca-certificates cmake dh-python doxygen flex gdal-bin git graphviz grass-dev libexpat1-dev libfcgi-dev libgdal-dev libgeos-dev libgsl-dev libpq-dev libproj-dev libqca-qt5-2-dev libqca-qt5-2-plugins libqt5opengl5-dev libqt5scintilla2-dev libqt5sql5-sqlite libqt5svg5-dev libqt5webkit5-dev libqt5xmlpatterns5-dev libqwt-qt5-dev libspatialindex-dev libspatialite-dev libsqlite3-dev libsqlite3-mod-spatialite lighttpd locales ninja-build pkg-config poppler-utils pyqt5-dev pyqt5-dev-tools pyqt5.qsci-dev python3-all-dev python3-dev python3-future python3-gdal python3-mock python3-nose2 python3-psycopg2 python3-pyqt5 python3-pyqt5.qsci python3-pyqt5.qtsql python3-pyqt5.qtsvg python3-sip python3-sip-dev python3-termcolor python3-yaml qt5keychain-dev qtbase5-dev qtpositioning5-dev qtscript5-dev qttools5-dev qttools5-dev-tools spawn-fcgi txt2tags xauth xfonts-100dpi xfonts-75dpi xfonts-base xfonts-scalable xvfb cmake-curses-gui expect</CODE></TD>
</TR>
<TR>
<TD>sid</TD>
<TD><CODE>apt-get install bison ca-certificates cmake dh-python doxygen flex gdal-bin git graphviz grass-dev libexpat1-dev libfcgi-dev libgdal-dev libgeos-dev libgsl-dev libosgearth-dev libpq-dev libproj-dev libqca-qt5-2-dev libqca-qt5-2-plugins libqt5opengl5-dev libqt5scintilla2-dev libqt5sql5-sqlite libqt5svg5-dev libqt5webkit5-dev libqt5xmlpatterns5-dev libqwt-qt5-dev libspatialindex-dev libspatialite-dev libsqlite3-dev libsqlite3-mod-spatialite lighttpd locales ninja-build pkg-config poppler-utils pyqt5-dev pyqt5-dev-tools pyqt5.qsci-dev python3-all-dev python3-dev python3-future python3-gdal python3-mock python3-nose2 python3-psycopg2 python3-pyqt5 python3-pyqt5.qsci python3-pyqt5.qtsql python3-pyqt5.qtsvg python3-sip python3-sip-dev python3-termcolor python3-yaml qt5keychain-dev qtbase5-dev qtpositioning5-dev qtscript5-dev qttools5-dev qttools5-dev-tools spawn-fcgi txt2tags xauth xfonts-100dpi xfonts-75dpi xfonts-base xfonts-scalable xvfb cmake-curses-gui expect</CODE></TD>
</TR>
</TABLE>
<P>
(extracted from the control.in file in <CODE>debian/</CODE>)
</P>
<A NAME="toc7"></A>
<H2>3.4. Setup ccache (Optional)</H2>
<P>
You should also setup ccache to speed up compile times:
</P>
<div class="code"><PRE>
cd /usr/local/bin
sudo ln -s /usr/bin/ccache gcc
sudo ln -s /usr/bin/ccache g++
</PRE></div>
<A NAME="toc8"></A>
<H2>3.5. Prepare your development environment</H2>
<P>
As a convention I do all my development work in $HOME/dev/&lt;language&gt;, so in
this case we will create a work environment for C++ development work like
this:
</P>
<div class="code"><PRE>
mkdir -p ${HOME}/dev/cpp
cd ${HOME}/dev/cpp
</PRE></div>
<P>
This directory path will be assumed for all instructions that follow.
</P>
<A NAME="toc9"></A>
<H2>3.6. Check out the QGIS Source Code</H2>
<P>
There are two ways the source can be checked out. Use the anonymous method
if you do not have edit privileges for the QGIS source repository, or use
the developer checkout if you have permissions to commit source code
changes.
</P>
<P>
1. Anonymous Checkout
</P>
<div class="code"><PRE>
cd ${HOME}/dev/cpp
git clone git://github.com/qgis/QGIS.git
</PRE></div>
<P>
2. Developer Checkout
</P>
<div class="code"><PRE>
cd ${HOME}/dev/cpp
git clone git@github.com:qgis/QGIS.git
</PRE></div>
<A NAME="toc10"></A>
<H2>3.7. Starting the compile</H2>
<P>
I compile my development version of QGIS into my ~/apps directory to avoid
conflicts with Ubuntu packages that may be under /usr. This way for example
you can use the binary packages of QGIS on your system along side with your
development version. I suggest you do something similar:
</P>
<div class="code"><PRE>
mkdir -p ${HOME}/apps
</PRE></div>
<P>
Now we create a build directory and run ccmake:
</P>
<div class="code"><PRE>
cd QGIS
mkdir build-master
cd build-master
ccmake ..
</PRE></div>
<P>
When you run ccmake (note the .. is required!), a menu will appear where
you can configure various aspects of the build. If you want QGIS to have
debugging capabilities then set CMAKE_BUILD_TYPE to Debug. If you do not have
root access or do not want to overwrite existing QGIS installs (by your
packagemanager for example), set the CMAKE_INSTALL_PREFIX to somewhere you
have write access to (I usually use ${HOME}/apps). Now press
'c' to configure, 'e' to dismiss any error messages that may appear.
and 'g' to generate the make files. Note that sometimes 'c' needs to
be pressed several times before the 'g' option becomes available.
After the 'g' generation is complete, press 'q' to exit the ccmake
interactive dialog.
</P>
<P>
/!\ <B>Warning:</B> Make sure that your build directory is completely empty when you
enter the command. Do never try to "re-use" an existing <B>Qt4</B> build directory.
If you want to use `ccmake` or other interactive tools, run the command in
the empty build directory once before starting to use the interactive tools.
</P>
<P>
Now on with the build:
</P>
<div class="code"><PRE>
make -jX
</PRE></div>
<P>
where X is the number of available cores. Depending on your platform,
this can speed up the build time considerably.
</P>
<P>
Then you can directly run from the build directory:
</P>
<div class="code"><PRE>
./output/bin/qgis
</PRE></div>
<P>
Another option is to install to your system:
</P>
<div class="code"><PRE>
make install
</PRE></div>
<P>
After that you can try to run QGIS:
</P>
<div class="code"><PRE>
$HOME/apps/bin/qgis
</PRE></div>
<P>
If all has worked properly the QGIS application should start up and appear
on your screen. If you get the error message "error while loading shared libraries",
execute this command in your shell.
</P>
<div class="code"><PRE>
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${HOME}/apps/lib/
</PRE></div>
<P>
Optionally, if you already know what aspects you want in your custom build
then you can skip the interactive ccmake .. part by using the cmake -D
option for each aspect, e.g.:
</P>
<div class="code"><PRE>
cmake -D CMAKE_BUILD_TYPE=Debug -D CMAKE_INSTALL_PREFIX=${HOME}/apps ..
</PRE></div>
<P>
Also, if you want to speed your build times, you can easily do it with ninja,
an alternative to make with similar build options.
</P>
<P>
For example, to configure your build you can do either one of:
</P>
<div class="code"><PRE>
ccmake -G Ninja ..
</PRE></div>
<div class="code"><PRE>
cmake -G Ninja -D CMAKE_BUILD_TYPE=Debug -D CMAKE_INSTALL_PREFIX=${HOME}/apps ..
</PRE></div>
<P>
Build and install with ninja:
</P>
<div class="code"><PRE>
ninja (uses all cores by default; also supports the above described -jX option)
ninja install
</PRE></div>
<A NAME="toc11"></A>
<H2>3.8. Building Debian packages</H2>
<P>
Instead of creating a personal installation as in the previous step you can
also create debian package. This is done from the QGIS root directory, where
you'll find a debian directory.
</P>
<P>
First you need to install the debian packaging tools once:
</P>
<div class="code"><PRE>
apt-get install build-essential
</PRE></div>
<P>
First you need to create an changelog entry for your distribution. For example
for Ubuntu Precise:
</P>
<div class="code"><PRE>
dch -l ~precise --force-distribution --distribution precise "precise build"
</PRE></div>
<P>
The QGIS packages will be created with:
</P>
<div class="code"><PRE>
dpkg-buildpackage -us -uc -b
</PRE></div>
<P>
/!\ <B>Note:</B> Install <CODE>devscripts</CODE> to get <CODE>dch</CODE>.
</P>
<P>
/!\ <B>Note:</B> If <CODE>dpkg-buildpackage</CODE> complains about unmet build dependencies
you can install them using <CODE>apt-get</CODE> and re-run the command.
</P>
<P>
/!\ <B>Note:</B> If you have <CODE>libqgis1-dev</CODE> installed, you need to remove it first
using <CODE>dpkg -r libqgis1-dev</CODE>. Otherwise <CODE>dpkg-buildpackage</CODE> will complain about a
build conflict.
</P>
<P>
/!\ <B>Note:</B> By default tests are run in the process of building and their
results are uploaded to <A HREF="http://dash.orfeo-toolbox.org/index.php?project=QGIS.">http://dash.orfeo-toolbox.org/index.php?project=QGIS.</A>
You can turn the tests off using DEB_BUILD_OPTIONS=nocheck in front of the
build command. The upload of results can be avoided with DEB_TEST_TARGET=test.
</P>
<P>
The packages are created in the parent directory (ie. one level up).
Install them using dpkg. E.g.:
</P>
<div class="code"><PRE>
sudo debi
</PRE></div>
<A NAME="toc12"></A>
<H2>3.9. On Fedora Linux</H2>
<P>
We assume that you have the source code of QGIS ready and created a
new subdirectory called `build` or `build-qt5` in it.
</P>
<H3>3.9.1. Install build dependencies</H3>
<div class="code"><PRE>
dnf install qt5-qtwebkit-devel qt5-qtlocation-devel qt5-qttools-static
qt5-qtscript-devel qca-qt5-devel python3-qt5-devel python3-qscintilla-qt5-devel
qscintilla-qt5-devel python3-qscintilla-devel python3-qscintilla-qt5
clang flex bison geos-devel gdal-devel sqlite-devel libspatialite-devel
qt5-qtsvg-devel qt5-qtxmlpatterns-devel spatialindex-devel expat-devel proj-devel
qwt-qt5-devel gsl-devel postgresql-devel cmake python3-future gdal-python3
python3-psycopg2 python3-PyYAML qca-qt5-ossl
</PRE></div>
<P>
To build QGIS server additional dependencies are required:
</P>
<div class="code"><PRE>
dnf install fcgi-devel
</PRE></div>
<P>
Make sure that your build directory is completely empty when you enter the
following command. Do never try to "re-use" an existing Qt4 build directory.
If you want to use `ccmake` or other interactive tools, run the following
command in the empty build directory once before starting to use the interactive
tools.
</P>
<div class="code"><PRE>
cmake ..
</PRE></div>
<P>
If everything went ok you can finally start to compile. (As usual append a -jX
where X is the number of available cores option to make to speed up your build
process)
</P>
<div class="code"><PRE>
make
</PRE></div>
<P>
Run from the build directory
</P>
<div class="code"><PRE>
./output/bin/qgis
</PRE></div>
<P>
Or install to your system
</P>
<div class="code"><PRE>
make install
</PRE></div>
<A NAME="toc13"></A>
<H1>4. Building on Windows</H1>
<A NAME="toc14"></A>
<H2>4.1. Building with Microsoft Visual Studio</H2>
<P>
This section describes how to build QGIS using Visual Studio on Windows. This
is currently also how the binary QGIS packages are made (earlier versions used
MinGW).
</P>
<P>
This section describes the setup required to allow Visual Studio to be used to
build QGIS.
</P>
<H3>4.1.1. Visual C++ Community Edition</H3>
<P>
The free (as in free beer) Community installer is available under:
</P>
<BLOCKQUOTE>
<A HREF="http://download.microsoft.com/download/D/2/3/D23F4D0F-BA2D-4600-8725-6CCECEA05196/vs_community_ENU.exe">http://download.microsoft.com/download/D/2/3/D23F4D0F-BA2D-4600-8725-6CCECEA05196/vs_community_ENU.exe</A>
</BLOCKQUOTE>
<H3>4.1.2. Other tools and dependencies</H3>
<P>
Download and install following packages:
</P>
<TABLE BORDER="1">
<TR>
<TH>Tool</TH>
<TH>Website</TH>
</TR>
<TR>
<TD>CMake</TD>
<TD><A HREF="https://cmake.org/files/v3.7/cmake-3.7.2-win64-x64.msi">https://cmake.org/files/v3.7/cmake-3.7.2-win64-x64.msi</A></TD>
</TR>
<TR>
<TD>GNU flex, GNU bison and GIT</TD>
<TD><A HREF="http://cygwin.com/setup-x86.exe">http://cygwin.com/setup-x86.exe</A> (32bit) or <A HREF="http://cygwin.com/setup-x86_64.exe">http://cygwin.com/setup-x86_64.exe</A> (64bit)</TD>
</TR>
<TR>
<TD>OSGeo4W</TD>
<TD><A HREF="http://download.osgeo.org/osgeo4w/osgeo4w-setup-x86.exe">http://download.osgeo.org/osgeo4w/osgeo4w-setup-x86.exe</A> (32bit) or <A HREF="http://download.osgeo.org/osgeo4w/osgeo4w-setup-x86_64.exe">http://download.osgeo.org/osgeo4w/osgeo4w-setup-x86_64.exe</A> (64bit)</TD>
</TR>
<TR>
<TD>ninja</TD>
<TD><A HREF="https://github.com/ninja-build/ninja/releases/download/v1.7.2/ninja-win.zip">https://github.com/ninja-build/ninja/releases/download/v1.7.2/ninja-win.zip</A></TD>
</TR>
</TABLE>
<P>
OSGeo4W does not only provide ready packages for the current QGIS release and
nightly builds of master, but also offers most of the dependencies needs to
build it.
</P>
<P>
For the QGIS build you need to install following packages from cygwin:
</P>
<UL>
<LI>bison
<LI>flex
<LI>git
</UL>
<P>
and from OSGeo4W (select <I>Advanced Installation</I>):
</P>
<UL>
<LI>expat
<LI>fcgi
<LI>gdal
<LI>grass
<LI>gsl-devel
<LI>iconv
<LI>libspatialindex-devel
<LI>pyqt5
<LI>python3-devel
<LI>python3-qscintilla
<LI>python3-nose2
<LI>python3-future
<LI>python3-pyyaml
<LI>python3-mock
<LI>qca-qt5-devel
<LI>qca-qt5-libs
<LI>qscintilla-qt5
<LI>qt5-devel
<LI>qt5-libs-debug
<LI>qtwebkit-qt5-devel
<LI>qtwebkit-qt5-libs-debug
<LI>qwt-devel-qt5
<LI>sip-qt5
<LI>spatialite
</UL>
<P>
This will also select packages the above packages depend on.
</P>
<P>
If you install other packages, this might cause issues. Particularly, make sure
<B>not</B> to install the msinttypes package. It installs a stdint.h file in
OSGeo4W[64]\include, that conflicts with Visual Studio own stdint.h, which for
example breaks the build of the virtuallayer provider.
</P>
<P>
Earlier versions of this document also covered how to build all above
dependencies. If you're interested in that, check the history of this page in the Wiki
or the SVN repository.
</P>
<H3>4.1.3. Setting up the Visual Studio project with CMake</H3>
<P>
/!\ Consider this section as example. It tends to outdate, when OSGeo4W and
SDKs move on. <CODE>ms-windows/osgeo4w/package-nightly.cmd</CODE> is used for the
nightly builds and constantly updated and hence might contain necessary
updates that are not yet reflected here.
</P>
<P>
To start a command prompt with an environment that both has the VC++ and the OSGeo4W
variables create the following batch file (assuming the above packages were
installed in the default locations):
</P>
<div class="code"><PRE>
@echo off
set VS90COMNTOOLS=%PROGRAMFILES%\Microsoft Visual Studio 9.0\Common7\Tools\
call "%PROGRAMFILES%\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x86
set INCLUDE=%INCLUDE%;%PROGRAMFILES%\Microsoft SDKs\Windows\v7.1\include
set LIB=%LIB%;%PROGRAMFILES%\Microsoft SDKs\Windows\v7.1\lib
set OSGEO4W_ROOT=C:\OSGeo4W
call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
path %PATH%;%PROGRAMFILES%\CMake\bin;c:\cygwin\bin
@set GRASS_PREFIX=c:/OSGeo4W/apps/grass/grass-6.4.4
@set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include
@set LIB=%LIB%;%OSGEO4W_ROOT%\lib;%OSGEO4W_ROOT%\lib
@cmd
</PRE></div>
<P>
Start the batch file and on the command prompt checkout the QGIS source from
git to the source directory <CODE>QGIS</CODE>:
</P>
<div class="code"><PRE>
git clone git://github.com/qgis/QGIS.git
</PRE></div>
<P>
Create a 'build' directory somewhere. This will be where all the build output
will be generated.
</P>
<P>
Now run <CODE>cmake-gui</CODE> (still from <CODE>cmd</CODE>) and in the <I>Where is the source code:</I>
box, browse to the top level QGIS directory.
</P>
<P>
In the <I>Where to build the binaries:</I> box, browse to the 'build' directory you
created.
</P>
<P>
If the path to bison and flex contains blanks, you need to use the short name
for the directory (i.e. <CODE>C:\Program Files</CODE> should be rewritten to
<CODE>C:\Progra~n</CODE>, where <CODE>n</CODE> is the number as shown in `dir /x C:\``).
</P>
<P>
Verify that the 'BINDINGS_GLOBAL_INSTALL' option is not checked, so that python
bindings are placed into the output directory when you run the INSTALL target.
</P>
<P>
Hit <CODE>Configure</CODE> to start the configuration and select <CODE>Visual Studio 9 2008</CODE>
and keep <CODE>native compilers</CODE> and click <CODE>Finish</CODE>.
</P>
<P>
The configuration should complete without any further questions and allow you to
click <CODE>Generate</CODE>.
</P>
<P>
Now close <CODE>cmake-gui</CODE> and continue on the command prompt by starting
<CODE>vcexpress</CODE>. Use File / Open / Project/Solutions and open the
qgis-x.y.z.sln File in your project directory.
</P>
<P>
Change <CODE>Solution Configuration</CODE> from <CODE>Debug</CODE> to <CODE>RelWithDebInfo</CODE> (Release
with Debug Info) or <CODE>Release</CODE> before you build QGIS using the ALL_BUILD
target (otherwise you need debug libraries that are not included).
</P>
<P>
After the build completed you should install QGIS using the INSTALL target.
</P>
<P>
Install QGIS by building the INSTALL project. By default this will install to
c:\Program Files\qgis&lt;version&gt; (this can be changed by changing the
CMAKE_INSTALL_PREFIX variable in cmake-gui).
</P>
<P>
You will also either need to add all the dependency DLLs to the QGIS install
directory or add their respective directories to your PATH.
</P>
<H3>4.1.4. Packaging</H3>
<P>
To create a standalone installer there is a perl script named 'creatensis.pl'
in 'qgis/ms-windows/osgeo4w'. It downloads all required packages from OSGeo4W
and repackages them into an installer using NSIS.
</P>
<P>
The script can be run on both Windows and Linux.
</P>
<P>
On Debian/Ubuntu you can just install the 'nsis' package.
</P>
<P>
NSIS for Windows can be downloaded at:
</P>
<BLOCKQUOTE>
<A HREF="http://nsis.sourceforge.net">http://nsis.sourceforge.net</A>
</BLOCKQUOTE>
<P>
And Perl for Windows (including other requirements like 'wget', 'unzip', 'tar'
and 'bzip2') is available at:
</P>
<BLOCKQUOTE>
<A HREF="http://cygwin.com">http://cygwin.com</A>
</BLOCKQUOTE>
<H3>4.1.5. Packaging your own build of QGIS</H3>
<P>
Assuming you have completed the above packaging step, if you want to include
your own hand built QGIS executables, you need to copy them in from your
windows installation into the ms-windows file tree created by the creatensis
script.
</P>
<div class="code"><PRE>
cd ms-windows/
rm -rf osgeo4w/unpacked/apps/qgis/*
cp -r /tmp/qgis1.7.0/* osgeo4w/unpacked/apps/qgis/
</PRE></div>
<P>
Now create a package.
</P>
<div class="code"><PRE>
./quickpackage.sh
</PRE></div>
<P>
After this you should now have a nsis installer containing your own build
of QGIS and all dependencies needed to run it on a windows machine.
</P>
<H3>4.1.6. Osgeo4w packaging</H3>
<P>
The actual packaging process is currently not documented, for now please take a
look at:
</P>
<P>
<I>ms-windows/osgeo4w/package.cmd</I>
</P>
<A NAME="toc15"></A>
<H2>4.2. Building using MinGW</H2>
<P>
<B>Note:</B> This section might be outdated as nowadays Visual C++ is use to build
the "official" packages.
</P>
<P>
<B>Note:</B> For a detailed account of building all the dependencies yourself you
can visit Marco Pasetti's website here:
</P>
<P>
<A HREF="http://www.webalice.it/marco.pasetti/qgis+grass/BuildFromSource.html">http://www.webalice.it/marco.pasetti/qgis+grass/BuildFromSource.html</A>
</P>
<P>
Read on to use the simplified approach with pre-built libraries...
</P>
<H3>4.2.1. MSYS</H3>
<P>
MSYS provides a unix style build environment under windows. We have created a
zip archive that contains just about all dependencies.
</P>
<P>
Get this:
</P>
<P>
<A HREF="http://download.osgeo.org/qgis/win32/msys.zip">http://download.osgeo.org/qgis/win32/msys.zip</A>
</P>
<P>
and unpack to c:\msys
</P>
<P>
If you wish to prepare your msys environment yourself rather than using
our pre-made one, detailed instructions are provided elsewhere in this
document.
</P>
<H3>4.2.2. Qt</H3>
<P>
Download Qt opensource precompiled edition exe and install (including the
download and install of mingw) from here:
</P>
<P>
<A HREF="http://qt.nokia.com/downloads/">http://qt.nokia.com/downloads/</A>
</P>
<P>
When the installer will ask for MinGW, you don't need to download and install
it, just point the installer to c:\msys\mingw
</P>
<P>
When Qt installation is complete:
</P>
<P>
Edit C:\Qt\4.8.0\bin\qtvars.bat and add the following lines:
</P>
<div class="code"><PRE>
set PATH=%PATH%;C:\msys\local\bin;c:\msys\local\lib
set PATH=%PATH%;"C:\Program Files\Subversion\bin"
</PRE></div>
<P>
I suggest you also add C:\Qt\4.8.0\bin\ to your Environment Variables Path in
the windows system preferences.
</P>
<P>
If you plan to do some debugging, you'll need to compile debug version of Qt:
C:\Qt\4.8.0\bin\qtvars.bat compile_debug
</P>
<P>
Note: there is a problem when compiling debug version of Qt 4.7, the script ends with
this message "mingw32-make: *** No rule to make target `debug'. Stop.". To
compile the debug version you have to go out of src directory and execute the
following command:
</P>
<div class="code"><PRE>
c:\Qt\4.8.0 make
</PRE></div>
<H3>4.2.3. Flex and Bison</H3>
<P>
Get Flex
<A HREF="http://sourceforge.net/project/showfiles.php?group_id=23617&amp;package_id=16424">http://sourceforge.net/project/showfiles.php?group_id=23617&amp;package_id=16424</A>
(the zip bin) and extract it into c:\msys\mingw\bin
</P>
<H3>4.2.4. Python stuff (optional)</H3>
<P>
Follow this section in case you would like to use Python bindings for QGIS. To
be able to compile bindings, you need to compile SIP and PyQt4 from sources as
their installer doesn't include some development files which are necessary.
</P>
<H4>4.2.4.1. Download and install Python - use Windows installer</H4>
<P>
(It doesn't matter to what folder you'll install it)
</P>
<P>
<A HREF="http://python.org/download/">http://python.org/download/</A>
</P>
<H4>4.2.4.2. Download SIP and PyQt4 sources</H4>
<P>
<A HREF="http://www.riverbankcomputing.com/software/sip/download">http://www.riverbankcomputing.com/software/sip/download</A>
<A HREF="http://www.riverbankcomputing.com/software/pyqt/download">http://www.riverbankcomputing.com/software/pyqt/download</A>
</P>
<P>
Extract each of the above zip files in a temporary directory. Make sure
to get versions that match your current Qt installed version.
</P>
<H4>4.2.4.3. Compile SIP</H4>
<div class="code"><PRE>
c:\Qt\4.8.0\bin\qtvars.bat
python configure.py -p win32-g++
make
make install
</PRE></div>
<H4>4.2.4.4. Compile PyQt</H4>
<div class="code"><PRE>
c:\Qt\4.8.0\bin\qtvars.bat
python configure.py
make
make install
</PRE></div>
<H4>4.2.4.5. Final python notes</H4>
<P>
/!\ You can delete the directories with unpacked SIP and PyQt4 sources after a
successful install, they're not needed anymore.
</P>
<H3>4.2.5. git</H3>
<P>
In order to check out QGIS sources from the repository, you need a git client.
This installer should work fine:
</P>
<P>
<A HREF="http://msysgit.googlecode.com/files/Git-1.7.4-preview20110204.exe">http://msysgit.googlecode.com/files/Git-1.7.4-preview20110204.exe</A>
</P>
<H3>4.2.6. CMake</H3>
<P>
CMake is build system used by QGIS. Download it from here:
</P>
<P>
<A HREF="http://www.cmake.org/files/v2.8/cmake-2.8.2-win32-x86.exe">http://www.cmake.org/files/v2.8/cmake-2.8.2-win32-x86.exe</A>
</P>
<H3>4.2.7. QGIS</H3>
<P>
Start a cmd.exe window ( Start -&gt; Run -&gt; cmd.exe ) Create development
directory and move into it
</P>
<div class="code"><PRE>
md c:\dev\cpp
cd c:\dev\cpp
</PRE></div>
<P>
Check out sources from GIT:
</P>
<div class="code"><PRE>
git clone git://github.com/qgis/QGIS.git
</PRE></div>
<H3>4.2.8. Compiling</H3>
<P>
As a background read the generic building with CMake notes at the end of
this document.
</P>
<P>
Start a cmd.exe window ( Start -&gt; Run -&gt; cmd.exe ) if you don't have one
already. Add paths to compiler and our MSYS environment:
</P>
<div class="code"><PRE>
c:\Qt\4.8.0\bin\qtvars.bat
</PRE></div>
<P>
For ease of use add c:\Qt\4.8.0\bin\ to your system path in system
properties so you can just type qtvars.bat when you open the cmd console.
Create build directory and set it as current directory:
</P>
<div class="code"><PRE>
cd c:\dev\cpp\qgis
md build
cd build
</PRE></div>
<H3>4.2.9. Configuration</H3>
<div class="code"><PRE>
cmakesetup ..
</PRE></div>
<P>
<B>Note:</B> You must include the '..' above.
</P>
<P>
Click 'Configure' button. When asked, you should choose 'MinGW Makefiles' as
generator.
</P>
<P>
There's a problem with MinGW Makefiles on Win2K. If you're compiling on this
platform, use 'MSYS Makefiles' generator instead.
</P>
<P>
All dependencies should be picked up automatically, if you have set up the
Paths correctly. The only thing you need to change is the installation
destination (CMAKE_INSTALL_PREFIX) and/or set 'Debug'.
</P>
<P>
For compatibility with NSIS packaging scripts I recommend to leave the install
prefix to its default c:\program files\
</P>
<P>
When configuration is done, click 'OK' to exit the setup utility.
</P>
<H3>4.2.10. Compilation and installation</H3>
<div class="code"><PRE>
make make install
</PRE></div>
<H3>4.2.11. Run qgis.exe from the directory where it's installed (CMAKE_INSTALL_PREFIX)</H3>
<P>
Make sure to copy all .dll:s needed to the same directory as the qgis.exe
binary is installed to, if not already done so, otherwise QGIS will complain
about missing libraries when started.
</P>
<P>
A possibility is to run qgis.exe when your path contains c:\msys\local\bin and
c:\msys\local\lib directories, so the DLLs will be used from that place.
</P>
<H3>4.2.12. Create the installation package: (optional)</H3>
<P>
Download and install NSIS from (<A HREF="http://nsis.sourceforge.net/Main_Page">http://nsis.sourceforge.net/Main_Page</A>)
</P>
<P>
Now using windows explorer, enter the win_build directory in your QGIS source
tree. Read the READMEfile there and follow the instructions. Next right click
on qgis.nsi and choose the option 'Compile NSIS Script'.
</P>
<A NAME="toc16"></A>
<H2>4.3. Creation of MSYS environment for compilation of QGIS</H2>
<H3>4.3.1. Initial setup</H3>
<H4>4.3.1.1. MSYS</H4>
<P>
This is the environment that supplies many utilities from UNIX world in Windows and is needed
by many dependencies to be able to compile.
</P>
<P>
Download from here:
</P>
<BLOCKQUOTE>
<A HREF="http://puzzle.dl.sourceforge.net/sourceforge/mingw/MSYS-1.0.11-2004.04.30-1.exe">http://puzzle.dl.sourceforge.net/sourceforge/mingw/MSYS-1.0.11-2004.04.30-1.exe</A>
</BLOCKQUOTE>
<P>
Install to <CODE>c:\msys</CODE>
</P>
<P>
All stuff we're going to compile is going to get to this directory (resp. its subdirs).
</P>
<H4>4.3.1.2. MinGW</H4>
<P>
Download from here:
</P>
<BLOCKQUOTE>
<A HREF="http://puzzle.dl.sourceforge.net/sourceforge/mingw/MinGW-5.1.3.exe">http://puzzle.dl.sourceforge.net/sourceforge/mingw/MinGW-5.1.3.exe</A>
</BLOCKQUOTE>
<P>
Install to <CODE>c:\msys\mingw</CODE>
</P>
<P>
It suffices to download and install only <CODE>g++</CODE> and <CODE>mingw-make</CODE> components.
</P>
<H4>4.3.1.3. Flex and Bison</H4>
<P>
Flex and Bison are tools for generation of parsers, they're needed for GRASS and also QGIS compilation.
</P>
<P>
Download the following packages:
</P>
<BLOCKQUOTE>
<A HREF="http://gnuwin32.sourceforge.net/downlinks/flex-bin-zip.php">http://gnuwin32.sourceforge.net/downlinks/flex-bin-zip.php</A>
</BLOCKQUOTE>
<BLOCKQUOTE>
<A HREF="http://gnuwin32.sourceforge.net/downlinks/bison-bin-zip.php">http://gnuwin32.sourceforge.net/downlinks/bison-bin-zip.php</A>
</BLOCKQUOTE>
<BLOCKQUOTE>
<A HREF="http://gnuwin32.sourceforge.net/downlinks/bison-dep-zip.php">http://gnuwin32.sourceforge.net/downlinks/bison-dep-zip.php</A>
</BLOCKQUOTE>
<P>
Unpack them all to <CODE>c:\msys\local</CODE>
</P>
<H3>4.3.2. Installing dependencies</H3>
<H4>4.3.2.1. Getting ready</H4>
<P>
Paul Kelly did a great job and prepared a package of precompiled libraries for GRASS.
The package currently includes:
</P>
<UL>
<LI>zlib-1.2.3
<LI>libpng-1.2.16-noconfig
<LI>xdr-4.0-mingw2
<LI>freetype-2.3.4
<LI>fftw-2.1.5
<LI>PDCurses-3.1
<LI>proj-4.5.0
<LI>gdal-1.4.1
</UL>
<P>
It's available for download here:
</P>
<BLOCKQUOTE>
<A HREF="http://www.stjohnspoint.co.uk/grass/wingrass-extralibs.tar.gz">http://www.stjohnspoint.co.uk/grass/wingrass-extralibs.tar.gz</A>
</BLOCKQUOTE>
<P>
Moreover he also left the notes how to compile it (for those interested):
</P>
<BLOCKQUOTE>
<A HREF="http://www.stjohnspoint.co.uk/grass/README.extralibs">http://www.stjohnspoint.co.uk/grass/README.extralibs</A>
</BLOCKQUOTE>
<P>
Unpack the whole package to <CODE>c:\msys\local</CODE>
</P>
<H4>4.3.2.2. GRASS</H4>
<P>
Grab sources from CVS or use a weekly snapshot, see:
</P>
<BLOCKQUOTE>
<A HREF="http://grass.itc.it/devel/cvs.php">http://grass.itc.it/devel/cvs.php</A>
</BLOCKQUOTE>
<P>
In MSYS console go to the directory where you've unpacked or checked out sources
(e.g. <CODE>c:\msys\local\src\grass-6.3.cvs</CODE>)
</P>
<P>
Run these commands:
</P>
<div class="code"><PRE>
export PATH="/usr/local/bin:/usr/local/lib:$PATH"
./configure --prefix=/usr/local --bindir=/usr/local --with-includes=/usr/local/include --with-libs=/usr/local/lib --with-cxx --without-jpeg \
--without-tiff --with-postgres=yes --with-postgres-includes=/local/pgsql/include --with-pgsql-libs=/local/pgsql/lib --with-opengl=windows --with-fftw \
--with-freetype --with-freetype-includes=/mingw/include/freetype2 --without-x --without-tcltk --enable-x11=no --enable-shared=yes \
--with-proj-share=/usr/local/share/proj
make
make install
</PRE></div>
<P>
It should get installed to <CODE>c:\msys\local\grass-6.3.cvs</CODE>
</P>
<P>
By the way, these pages might be useful:
</P>
<UL>
<LI><A HREF="http://grass.gdf-hannover.de/wiki/WinGRASS_Current_Status">http://grass.gdf-hannover.de/wiki/WinGRASS_Current_Status</A>
<LI><A HREF="http://geni.ath.cx/grass.html">http://geni.ath.cx/grass.html</A>
</UL>
<H4>4.3.2.3. GEOS</H4>
<P>
Download the sources:
</P>
<BLOCKQUOTE>
<A HREF="http://geos.refractions.net/geos-2.2.3.tar.bz2">http://geos.refractions.net/geos-2.2.3.tar.bz2</A>
</BLOCKQUOTE>
<P>
Unpack to e.g. <CODE>c:\msys\local\src</CODE>
</P>
<P>
To compile, I had to patch the sources: in file <CODE>source/headers/timeval.h</CODE> line 13.
Change it from:
</P>
<div class="code"><PRE>
#ifdef _WIN32
</PRE></div>
<P>
to:
</P>
<div class="code"><PRE>
#if defined(_WIN32) &amp;&amp; defined(_MSC_VER)
</PRE></div>
<P>
Now, in MSYS console, go to the source directory and run:
</P>
<div class="code"><PRE>
./configure --prefix=/usr/local
make
make install
</PRE></div>
<H4>4.3.2.4. SQLITE</H4>
<P>
You can use precompiled DLL, no need to compile from source:
</P>
<P>
Download this archive:
</P>
<BLOCKQUOTE>
<A HREF="http://www.sqlite.org/sqlitedll-3_3_17.zip">http://www.sqlite.org/sqlitedll-3_3_17.zip</A>
</BLOCKQUOTE>
<P>
and copy sqlite3.dll from it to <CODE>c:\msys\local\lib</CODE>
</P>
<P>
Then download this archive:
</P>
<BLOCKQUOTE>
<A HREF="http://www.sqlite.org/sqlite-source-3_3_17.zip">http://www.sqlite.org/sqlite-source-3_3_17.zip</A>
</BLOCKQUOTE>
<P>
and copy sqlite3.h to <CODE>c:\msys\local\include</CODE>
</P>
<H4>4.3.2.5. GSL</H4>
<P>
Download sources:
</P>
<BLOCKQUOTE>
<A HREF="ftp://ftp.gnu.org/gnu/gsl/gsl-1.9.tar.gz">ftp://ftp.gnu.org/gnu/gsl/gsl-1.9.tar.gz</A>
</BLOCKQUOTE>
<P>
Unpack to <CODE>c:\msys\local\src</CODE>
</P>
<P>
Run from MSYS console in the source directory:
</P>
<div class="code"><PRE>
./configure
make
make install
</PRE></div>
<H4>4.3.2.6. EXPAT</H4>
<P>
Download sources:
</P>
<BLOCKQUOTE>
<A HREF="http://dfn.dl.sourceforge.net/sourceforge/expat/expat-2.0.0.tar.gz">http://dfn.dl.sourceforge.net/sourceforge/expat/expat-2.0.0.tar.gz</A>
</BLOCKQUOTE>
<P>
Unpack to <CODE>c:\msys\local\src</CODE>
</P>
<P>
Run from MSYS console in the source directory:
</P>
<div class="code"><PRE>
./configure
make
make install
</PRE></div>
<H4>4.3.2.7. POSTGRES</H4>
<P>
We're going to use precompiled binaries. Use the link below for download:
</P>
<BLOCKQUOTE>
<A HREF="http://wwwmaster.postgresql.org/download/mirrors-ftp?file=%2Fbinary%2Fv8.2.4%2Fwin32%2Fpostgresql-8.2.4-1-binaries-no-installer.zip">http://wwwmaster.postgresql.org/download/mirrors-ftp?file=%2Fbinary%2Fv8.2.4%2Fwin32%2Fpostgresql-8.2.4-1-binaries-no-installer.zip</A>
</BLOCKQUOTE>
<P>
copy contents of pgsql directory from the archive to <CODE>c:\msys\local</CODE>
</P>
<H3>4.3.3. Cleanup</H3>
<P>
We're done with preparation of MSYS environment. Now you can delete all stuff in <CODE>c:\msys\local\src</CODE> - it takes quite a lot
of space and it's not necessary at all.
</P>
<A NAME="toc17"></A>
<H1>5. Building on MacOS X</H1>
<P>
In this approach I will try to avoid as much as possible building dependencies
from source and rather use frameworks wherever possible.
</P>
<P>
"Universal", SDK and non-default arch builds require more complex options and
some fiddling with the system. It is best to stick with a single, default,
architecture build and follow these instructions for an initial build.
Included are notes for building on Mac OS X 10.5 (<U>Leopard</U>), 10.6
(<U>Snow Leopard</U>), 10.7 (<U>Lion</U>), 10.8 (<U>Mt. Lion</U>) and 10.9 (<U>Mavericks</U>)
(These names will be used throughout the instructions.)
Make sure to read each section completely before typing the first command you see.
</P>
<P>
<U>General note on Terminal usage:</U> When I say "cd" to a folder in a Terminal,
it means type "cd " (without the quotes, make sure to type a space after) and
then type the path to said folder, then &lt;return&gt;. A simple way to do this
without having to know and type the full path is, after type the "cd " part,
drag the folder (use the icon in its window title bar, or drag a folder from
within a window) from the Desktop to the Terminal, then tap &lt;return&gt;.
</P>
<P>
<U>Parallel Compilation:</U> On multiprocessor/multicore Macs, it's possible to
speed up compilation, but it's not automatic. Whenever you type "make" (but
NOT "make install"), instead type:
</P>
<div class="code"><PRE>
make -j [#cpus]
</PRE></div>
<P>
Replace [#cpus] with the number of cores and/or processors your Mac has. On recent
models with hyperthreading processors this can be double the physical count of
processors and cores.
</P>
<P>
ie: Mac Pro "8 Core" model (2 quad core processors) = 8
</P>
<P>
ie: Macbook Pro i5 (hyperthreading) = 2 cores X 2 = 4
</P>
<P>
To find out how many CPUs you have available, run the following in Terminal:
</P>
<div class="code"><PRE>
/usr/sbin/sysctl -n hw.ncpu
</PRE></div>
<P>
which can be used in build shell scripts like:
</P>
<div class="code"><PRE>
make -j $(/usr/sbin/sysctl -n hw.ncpu)
</PRE></div>
<P>
<U>Note:</U> if you get an error in parallel compilation, try removing the -j # flag,
so it's just 'make', or using a smaller number. Sometimes make can hiccup on too
many threads.
</P>
<A NAME="toc18"></A>
<H2>5.1. Install Developer Tools</H2>
<P>
Developer tools are not a part of a standard OS X installation. Up through
Snow Leopard, the Developer Tools, later called Xcode, were included with the
system install disks, though it's best to download the latest version compatible
with your system to get important updates fixing various issues.
Starting with Lion, Xcode is available as a download and from the App Store.
</P>
<P>
Downloading Xcode/Developer Tools for up through Snow Leopard requires a free developer account at
developer.apple.com. Up through Snow Leopard, get the latest <U>Xcode</U> that is
supported for your system. For Lion and above, you can get Xcode from either a
free developer account or for a minimal fee from the app store.
When installing Xcode up through Snow Leopard, make sure to
do a custom install and install the Unix Development or Command Line Tools option.
</P>
<P>
On Lion, if you have installed Xcode 4.0 - 4.2 and are upgrading to 4.3, it's
a good idea to uninstall the old version first with:
</P>
<div class="code"><PRE>
sudo /Developer/Library/uninstall-devtools
</PRE></div>
<P>
On Lion and Mt. Lion, using Xcode 4.4+, the developer command line tools can be
installed via the Xcode preferences.
</P>
<P>
Xcode 4.3+ also introduces the clang frontend to the LLVM compiler as default.
</P>
<P>
<B>Note:</B> In XCODE 4.5 installed from the app store, you need to install the
command line tools from XCode -&gt; Preferences -&gt; Downloads and choose command line tools.
</P>
<P>
<A HREF="http://clang.llvm.org/">http://clang.llvm.org/</A>
</P>
<P>
The supplied clang version 4 can compile QGIS, but presents many warnings
compared to just using LLVM. You can specifically use LLVM by exporting paths to
the compilers in Terminal, or shell scripts, prior to building QGIS:
</P>
<div class="code"><PRE>
export CC=/usr/bin/llvm-gcc
export CXX=/usr/bin/llvm-g++
</PRE></div>
<P>
If you have trouble building some of the dependencies listed below with clang
(e.g. OSG &amp; osgEarth), try using only the LLVM compilers.
</P>
<A NAME="toc19"></A>
<H2>5.2. Install Qt4 from disk image</H2>
<P>
You need a minimum of Qt-4.4.0. I suggest getting the latest (Qt 4, not 5). There is no need
for the full Qt SDK, so save yourself some download time and get the frameworks
only. This is available in the Libraries section of the Qt download page.
</P>
<P>
<U>Snow Leopard+ note:</U> If you are building on Snow Leopard+, you will need to
decide between 32-bit support in the older Qt Carbon branch, or 64-bit
support in the Qt Cocoa branch. Appropriate installers are available for both
as of Qt-4.5.2, though they stopped making Carbon packages at Qt 4.7.4.
Qt 4.6+ is recommended for Cocoa.
Starting with Lion, Carbon may not work properly, if at all.
Starting with Qt 4.8, only 64bit Cocoa installers are available.
</P>
<P>
<U>General note:</U> Support for new system versions in any given Qt version may
not be present and may cause a 'This version of Mac OS X
is unsupported' error when building QGIS. Try the next Qt version.
</P>
<P>
<U>PPC note:</U> The readymade Qt Cocoa installers don't include PPC support, you'd
have to compile Qt yourself. But, there appear to be issues with Qt Cocoa on
PPC Macs anyways. Qt Carbon is recommended on PPC Macs.
</P>
<P>
<A HREF="http://qt-project.org/downloads">http://qt-project.org/downloads</A>
</P>
<P>
If you want debug frameworks, Qt also provides a separate download with these.
These are in addition to the non-debug frameworks.
</P>
<P>
Earlier OS X systems may need an old Qt version - check the requirements of the
current Qt version. To get old Qt downloads, there is an FTP link at the bottom
of the download page. Files are in the qt/source (yes, even the binary packages).
</P>
<P>
Once downloaded open the disk image and run the installer. Note you need admin
privileges to install.
</P>
<P>
<U>Leopard+ note:</U> Qt includes a couple non-framework libraries in /usr/lib.
When using a system SDK these libraries will not be found. To fix this problem,
add symlinks to /usr/local:
</P>
<div class="code"><PRE>
sudo ln -s /usr/lib/libQtUiTools.a /usr/local/lib/
sudo ln -s /usr/lib/libQtCLucene.dylib /usr/local/lib/
</PRE></div>
<P>
These should then be found automatically. Earlier systems
may need some help by adding '-L/usr/local/lib' to CMAKE_SHARED_LINKER_FLAGS,
CMAKE_MODULE_LINKER_FLAGS and CMAKE_EXE_LINKER_FLAGS in the cmake build.
</P>
<A NAME="toc20"></A>
<H2>5.3. Install CMake for OSX</H2>
<P>
Get the latest source release from here:
</P>
<P>
<A HREF="http://www.cmake.org/cmake/resources/software.html">http://www.cmake.org/cmake/resources/software.html</A>
</P>
<P>
Binary installers are available for OS X, but they are not recommended
(2.4 versions install in /usr instead of /usr/local, and 2.6+ versions are a
strange application). Instead, download the source.
NOTE: 2.8.5 is broken for detecting part of Qt. Fixed in 2.8.6.
Double-click the source tarball to unpack it, then cd to the source folder and:
</P>
<div class="code"><PRE>
./bootstrap --docdir=/share/doc/CMake --mandir=/share/man
make -j [#cpus]
sudo make install
</PRE></div>
<H3>5.3.1. Optional setup: ccache</H3>
<P>
<U>Xcode 4.4+ note:</U> You will probably not need to install ccache if you are using
the clang frontend to LLVM compiler, a setup that already provides fairly quick
compile times.
</P>
<P>
Setup ccache to significantly speed up compile times after initial build.
(Switching git branches will again cause longer initial build times unless
separate build directories are used for each branch.)
</P>
<P>
Get the latest source release from here:
</P>
<P>
<A HREF="http://ccache.samba.org/">http://ccache.samba.org/</A>
</P>
<P>
Double-click the source tarball to unpack, then, in Terminal.app, cd to the
source folder and:
</P>
<div class="code"><PRE>
./configure
make
sudo make install
</PRE></div>
<P>
After install, symbolically link compilers to /usr/local/bin/ccache.
(Note: this differs from instructions at <A HREF="http://ccache.samba.org/manual.html">http://ccache.samba.org/manual.html</A>
Changing the /usr/bin:/usr/local/bin order in PATH is not recommended on OS X.
</P>
<div class="code"><PRE>
sudo mkdir /usr/local/bin/compilers &amp;&amp; cd /usr/local/bin/compilers
sudo ln -s ../ccache gcc
sudo ln -s ../ccache g++
sudo ln -s ../ccache cc
sudo ln -s ../ccache c++
</PRE></div>
<P>
Add the following to the end of your ~/.bash_profile (and optionally ~/.bashrc)
to allow your login shell to discover the symbolically linked compilers before
/usr/bin compilers and to easily toggle using ccache off, by commenting out the
line and starting a new login session in Terminal.
</P>
<div class="code"><PRE>
export PATH=/usr/local/bin/compilers:$PATH
</PRE></div>
<P>
If you have trouble building some of the dependencies listed below (e.g. OSG &amp;
osgEarth), try bypassing ccache.
</P>
<A NAME="toc21"></A>
<H2>5.4. Install development frameworks for QGIS dependencies</H2>
<P>
Download William Kyngesburye's excellent GDAL Complete package that includes
PROJ, GEOS, GDAL, SQLite3, Spatialite, and image libraries, as frameworks.
There are also GSL and FreeType frameworks.
</P>
<P>
<A HREF="http://www.kyngchaos.com/software/frameworks">http://www.kyngchaos.com/software/frameworks</A>
</P>
<P>
Once downloaded, open and install the frameworks.
</P>
<P>
William provides an additional installer package for Postgresql (for PostGIS
support). QGIS just needs the libpq client library, so unless you want to
setup the full Postgres + PostGIS server, all you need is the client-only
package. It's available here:
</P>
<P>
<A HREF="http://www.kyngchaos.com/software/postgres">http://www.kyngchaos.com/software/postgres</A>
</P>
<P>
Also available is a GRASS application:
</P>
<P>
<A HREF="http://www.kyngchaos.com/software/grass">http://www.kyngchaos.com/software/grass</A>
</P>
<P>
Old versions of these packages for older systems are available in the
software archive section.
</P>
<H3>5.4.1. Additional dependencies: General compatibility note</H3>
<P>
There are some additional dependencies that, at the time of writing, are not
provided as frameworks or installers so we will need to build these from source.
If you are wanting to build QGIS as a 64-bit application, you will need to
provide the appropriate build commands to produce 64-bit support in dependencies.
Likewise, for 32-bit support on Snow Leopard, you will need to override the
default system architecture, which is 64-bit, according to instructions for
individual dependency packages.
</P>
<P>
Stable release versions are preferred. Beta and other development versions may
have problems and you are on your own with those.
</P>
<H3>5.4.2. Additional dependencies: Expat</H3>
<P>
<U>Snow Leopard+ note:</U> Snow Leopard includes a usable expat, so this step is
not necessary on Snow Leopard or above.
</P>
<P>
Get the expat sources:
</P>
<P>
<A HREF="http://sourceforge.net/project/showfiles.php?group_id=10127">http://sourceforge.net/project/showfiles.php?group_id=10127</A>
</P>
<P>
Double-click the source tarball to unpack, then, in Terminal.app, cd to the
source folder and:
</P>
<div class="code"><PRE>
./configure
make
sudo make install
</PRE></div>
<H3>5.4.3. Additional dependencies: Spatialindex</H3>
<P>
Get the libspatialindex sources:
</P>
<P>
<A HREF="http://download.osgeo.org/libspatialindex/">http://download.osgeo.org/libspatialindex/</A>
</P>
<P>
Double-click the source tarball to unpack, then, in Terminal.app, cd to the
source folder and:
</P>
<div class="code"><PRE>
./configure --disable-dependency-tracking CFLAGS=-Os
make
sudo make install
</PRE></div>
<H3>5.4.4. Additional dependencies: Python</H3>
<P>
<U>Leopard+ note:</U> Starting with Leopard a usable Python is included
in the system. This is Python 2.5, 2.6 and 2.7, respectively for Leo, Snow and Lion+.
So there is no need to install Python on Leopard and newer.
You can still install Python from python.org if preferred.
</P>
<P>
If installing from python.org, make sure you install the latest Python
2.x from
</P>
<P>
<A HREF="http://www.python.org/download/">http://www.python.org/download/</A>
</P>
<P>
Python 3 is a major change, and may have compatibility issues, so try it at
your own risk.
</P>
<H3>5.4.5. Additional dependencies: SIP</H3>
<P>
<U>Mt Lion note:</U> SIP 4.15.7 appears to not work on Mt Lion. Install either
a prior version to 4.14.6 or a later version 4.16.3+
</P>
<P>
Retrieve the python bindings toolkit SIP from
</P>
<P>
<A HREF="http://www.riverbankcomputing.com/software/sip/download">http://www.riverbankcomputing.com/software/sip/download</A>
</P>
<P>
Double-click the source tarball to unpack it, then, in Terminal.app,
cd to the source folder. Then for your chosen Python:
</P>
<P>
<U>python.org Python</U>
</P>
<div class="code"><PRE>
python configure.py
make
sudo make install
</PRE></div>
<P>
<U>Leopard system Python</U>
</P>
<P>
SIP wants to install in the system path -- this is not a good idea.
More configuration is needed to install outside the system path:
</P>
<div class="code"><PRE>
python configure.py -n -d /Library/Python/2.5/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip -s MacOSX10.5.sdk
</PRE></div>
<P>
<U>Snow Leopard system Python</U>
</P>
<P>
Similar to Leopard, you should install outside the system Python path.
Also, you need to specify the architecture you want and make sure to run the
versioned python binary (this one responds to the 'arch' command, 'python' does
not). Substitute '2.7' for python version and 10.7 for SDK version below for
Lion.
</P>
<P>
If you are using 32-bit Qt (Qt Carbon):
</P>
<div class="code"><PRE>
python2.6 configure.py -n -d /Library/Python/2.6/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip --arch=i386 -s MacOSX10.6.sdk
</PRE></div>
<P>
For 64-bit Qt (Qt Cocoa), use this configure line:
</P>
<div class="code"><PRE>
python2.6 configure.py -n -d /Library/Python/2.6/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip --arch=x86_64 -s MacOSX10.6.sdk
</PRE></div>
<P>
<U>Lion+ system Python</U>
</P>
<P>
Similar to Snow Leopard, you should install outside the system Python path.
The SDK option should match the system you are compiling on:
</P>
<P>
for Lion:
</P>
<div class="code"><PRE>
python2.7 configure.py -d /Library/Python/2.7/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip --arch=x86_64 -s MacOSX10.7.sdk
</PRE></div>
<P>
for Mt. Lion:
</P>
<div class="code"><PRE>
python2.7 configure.py -d /Library/Python/2.7/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip --arch=x86_64 -s MacOSX10.8.sdk
</PRE></div>
<P>
for Mavericks:
</P>
<div class="code"><PRE>
python2.7 configure.py -d /Library/Python/2.7/site-packages -b /usr/local/bin \
-e /usr/local/include -v /usr/local/share/sip --arch=x86_64 -s MacOSX10.9.sdk
</PRE></div>
<P>
<U>continue...</U>
</P>
<P>
Then continue with compilation and installation:
</P>
<div class="code"><PRE>
make
sudo make install
</PRE></div>
<H3>5.4.6. Additional dependencies: QScintilla2</H3>
<P>
Retrieve the Qt version of the Scintilla-based text editor widget from
</P>
<P>
<A HREF="http://www.riverbankcomputing.co.uk/software/qscintilla/download">http://www.riverbankcomputing.co.uk/software/qscintilla/download</A>
</P>
<P>
Double-click the tarball to unpack it. Then, cd to the QScintilla2.x.x source
folder in a Terminal.
</P>
<P>
QScintilla2 wants to install in the system path -- with libraries going into
/Library/Frameworks and headers into /usr/include/Qsci -- this is not a good
idea, and it also basically breaks the QtDesigner plugin. More configuration
is needed to install outside the system path, in /usr/local/:
</P>
<div class="code"><PRE>
cd Qt4Qt5
</PRE></div>
<P>
Edit QScintilla-gpl-2.x.x/Qt4Qt5/qscintilla.pro in the following manner:
</P>
<div class="code"><PRE>
current line --&gt; new line
target.path = $$[QT_INSTALL_LIBS] --&gt; target.path = /usr/local/lib
header.path = $$[QT_INSTALL_HEADERS] --&gt; header.path = /usr/local/include
</PRE></div>
<P>
Save the qscintilla.pro file and build the QScintilla2 C++ library:
</P>
<div class="code"><PRE>
qmake -spec macx-g++ qscintilla.pro
make -j [#cpus]
sudo make install
</PRE></div>
<P>
adjust the install_name_tool command for the version installed of QScintilla installed:
</P>
<div class="code"><PRE>
sudo install_name_tool -id /usr/local/lib/libqscintilla2.11.dylib \
/usr/local/lib/libqscintilla2.11.dylib
</PRE></div>
<P>
This installs QScintilla2's dylib in /usr/local/lib/ and the header files in
/usr/local/include/Qsci/, both of which should be automatically found when
building QGIS.
</P>
<H4>5.4.6.1. Optional setup: QScintilla2 QtDesigner plugin</H4>
<P>
The plugin allows QScintilla2 widgets to be used within QtDesigner.
</P>
<div class="code"><PRE>
cd &lt;QScintilla2 source directory&gt;
cd designer-Qt4Qt5
qmake -spec macx-g++ designer.pro
make
sudo make install
</PRE></div>
<P>
Installs in /Developer/Applications/Qt/plugins/designer/
</P>
<H3>5.4.7. Additional dependencies: PyQt</H3>
<P>
Retrieve the python bindings toolkit for Qt from
</P>
<P>
<A HREF="http://www.riverbankcomputing.com/software/pyqt/download">http://www.riverbankcomputing.com/software/pyqt/download</A>
</P>
<P>
Double-click the source tarball to unpack it, then, in Terminal.app,
cd to the source folder. Then for your chosen Python:
</P>
<P>
<U>python.org Python</U>
</P>
<div class="code"><PRE>
python configure.py -n /usr/local/Qt4.8/qsci
yes
</PRE></div>
<P>
<U>Leopard system Python</U>
</P>
<P>
PyQt wants to install in the system path -- this is not a good idea.
More configuration is needed to install outside the system path:
</P>
<div class="code"><PRE>
python configure.py -d /Library/Python/2.5/site-packages -b /usr/local/bin -n /usr/local/Qt4.8/qsci -v /usr/local/share/sip/PyQt4
</PRE></div>
<P>
<U>Snow Leopard system Python</U>
</P>
<P>
Similar to Leopard, you should install outside the system Python path.
Also, you need to specify the architecture you want (requires at least PyQt 4.6),
and make sure to run the versioned python binary (this one responds to the
'arch' command, which is important for pyuic4, 'python' does not).
Substitute '2.7' for python version and 10.7 for SDK version below for Lion.
</P>
<P>
If you are using 32-bit Qt (Qt Carbon):
</P>
<div class="code"><PRE>
python2.6 configure.py -d /Library/Python/2.6/site-packages -b /usr/local/bin \
-n /usr/local/Qt4.8/qsci -v /usr/local/share/sip/PyQt4 --use-arch i386
</PRE></div>
<P>
For 64-bit Qt (Qt Cocoa), use this configure line:
</P>
<div class="code"><PRE>
python2.6 configure.py -d /Library/Python/2.6/site-packages -b /usr/local/bin \
-n /usr/local/Qt4.8/qsci -v /usr/local/share/sip/PyQt4 --use-arch x86_64
</PRE></div>
<P>
<U>Lion, Mt. Lion, and Mavericks system Python</U>
</P>
<P>
Similar to Snow Leopard, you should install outside the system Python path.
But you don't need the use-arch option:
</P>
<div class="code"><PRE>
python2.7 configure.py -d /Library/Python/2.7/site-packages -b /usr/local/bin -n /usr/local/Qt4.8/qsci -v /usr/local/share/sip/PyQt4
</PRE></div>
<P>
<U>continue...</U>
</P>
<div class="code"><PRE>
make -j [#cpus]
sudo make install
</PRE></div>
<P>
If there is a problem with undefined symbols in QtOpenGL on Leopard, edit
QtOpenGL/makefile and add -undefined dynamic_lookup to LFLAGS.
Then make again.
</P>
<H3>5.4.8. Additional dependencies: QScintilla2 Python Module</H3>
<P>
This will create the Qsci.so module in /Library/Python/2.x/site-packages/PyQt4.
Like PyQt, it needs help to not install in system locations.
</P>
<P>
<U>Snow Leopard:</U> substitute '2.6' for Python version
</P>
<div class="code"><PRE>
cd &lt;QScintilla2 source dir&gt;
cd Python
python2.7 configure.py -o /usr/local/lib -n /usr/local/include \
-d /Library/Python/2.7/site-packages/PyQt4 -v /usr/local/share/sip/PyQt4 \
--sip-incdir=/usr/local/include --pyqt-sipdir=/usr/local/share/sip/PyQt4
cat &gt;&gt;Qsci.pro &lt;&lt;EOF
QMAKE_LFLAGS_PLUGIN -= -dynamiclib
QMAKE_LFLAGS_PLUGIN += -bundle
EOF
qmake -spec macx-g++ Qsci.pro
make -j [#cpus]
sudo make install
</PRE></div>
<P>
The -o and -n options should match the QScintilla2 C++ dylib install options.
</P>
<H3>5.4.9. Additional dependencies: Qwt</H3>
<P>
The GPS tracking feature uses Qwt.
</P>
<P>
NOTE: PyQwt is not compatible with PyQt 4.9, so we will skip that.
</P>
<P>
Download the latest Qwt 6.0 source (6.1 does not work with the QwtPolar in QGIS) from:
</P>
<P>
<A HREF="http://sourceforge.net/projects/qwt">http://sourceforge.net/projects/qwt</A>
</P>
<P>
Double-click the tarball to unpack it. Now, cd to the qwt source folder in a
Terminal.
</P>
<P>
Type these commands to build and install 6.0.x (assumes v6.0.2, adjust commands
for other version as needed):
</P>
<div class="code"><PRE>
cat &gt;&gt; qwtconfig.pri &lt;&lt;EOF
QWT_CONFIG -= QwtFramework
EOF
qmake -spec macx-g++
make -j [#cpus]
sudo make install
sudo install_name_tool -id /usr/local/qwt-6.0.2/lib/libqwt.6.dylib \
/usr/local/qwt-6.0.2/lib/libqwt.6.dylib
</PRE></div>
<P>
The Qwt shared library is now installed in /usr/local/qwt-6.0.x (x is
the point version). Remember this for QGIS configuration.
</P>
<H3>5.4.10. Additional dependencies: Bison</H3>
<P>
The version of bison available by default on Mac OS X is too old so you
need to get a more recent one on your system. Download at least version 2.4 from:
</P>
<div class="code"><PRE>
ftp.gnu.org/gnu/bison/
</PRE></div>
<P>
Now build and install it to a prefix of /usr/local. Double-click the source
tarball to unpack it, then cd to the source folder and:
</P>
<div class="code"><PRE>
./configure --disable-dependency-tracking CFLAGS=-Os
make
sudo make install
</PRE></div>
<H3>5.4.11. Additional dependencies: gpsbabel</H3>
<P>
For integrated GPS Tools functions, a gpsbabel executable is required. You can
find this at:
</P>
<P>
<A HREF="http://www.gpsbabel.org/">http://www.gpsbabel.org/</A>
</P>
<P>
Download the GPSBabel OS X package, and copy GPSBabelFE.app from the disk image to
/Applications.
</P>
<H3>5.4.12. Optional dependencies: libfcgi</H3>
<P>
If you want to use the QGIS Mapserver, you need libfcgi. This is included on
systems up through Snow Leopard, but was dropped at Lion. So, on Lion you need
to get the source from:
</P>
<P>
<A HREF="http://www.fastcgi.com/dist/">http://www.fastcgi.com/dist/</A>
</P>
<P>
Grab the latest fcgi SNAP package there. Double-click the source
tarball to unpack it, then cd to the source folder and:
</P>
<div class="code"><PRE>
./configure --disable-dependency-tracking CFLAGS=-Os
make
sudo make install
</PRE></div>
<H3>5.4.13. Optional dependencies: OSG &amp; osgEarth</H3>
<P>
If you want the Globe plugin in QGIS (default OFF), OSG and osgEarth are needed.
</P>
<P>
First, <B>OpenSceneGraph</B>. The main site is very out of date, just go to
github:
</P>
<P>
<A HREF="http://github.com/openscenegraph/osg/tags">http://github.com/openscenegraph/osg/tags</A>
</P>
<P>
Download the latest 3.1 version (you can select a tarball when you hover over
the entry). Double-click the source tarball to unpack it.
(There is a version numbering oddity in the source, but since we'll be
bundling OSG as it's meant to be, it really doesn't matter).
</P>
<P>
Installation is a bit out of touch with OS X standards, so we'll stage it to a
temporary location first. You could stage it to the folder that the OSG source
folder is in, or a common staging area like /Users/Shared/unix/osg. Pick a
folder not hidden and that doesn't need admin permissions to write to for simplicity.
</P>
<P>
If you are building on Leopard, its configure forces a old ppc/i386 32bit build.
If you want 64bit you need to fix CMakeLists.txt - in a text editor, find the
if-block that starts with:
</P>
<div class="code"><PRE>
ELSEIF(${OSG_OSX_SDK_NAME} STREQUAL "macosx10.6" OR ${OSG_OSX_SDK_NAME} STREQUAL "macosx10.5")
</PRE></div>
<P>
In that section before the next ELSEIF, change:
</P>
<div class="code"><PRE>
ppc;i386
</PRE></div>
<P>
to:
</P>
<div class="code"><PRE>
i386;x86_64
</PRE></div>
<P>
and change:
</P>
<div class="code"><PRE>
mmacosx-version-min=10.5
</PRE></div>
<P>
to:
</P>
<div class="code"><PRE>
mmacosx-version-min=10.6
</PRE></div>
<P>
In a new Terminal cd to the source folder and:
</P>
<div class="code"><PRE>
mkdir build
cd build
cmake -D CMAKE_INSTALL_PREFIX=/path/to/some/staging/folder \
-D OSG_COMPILE_FRAMEWORKS=ON \
-D OSG_PLUGIN_SEARCH_INSTALL_DIR_FOR_PLUGINS=OFF \
-D JASPER_LIBRARY=/Library/Frameworks/UnixImageIO.framework \
-D JASPER_INCLUDE_DIR=/Library/Frameworks/UnixImageIO.framework/Headers \
-D TIFF_LIBRARY=/Library/Frameworks/UnixImageIO.framework \
-D TIFF_INCLUDE_DIR=/Library/Frameworks/UnixImageIO.framework/Headers \
..
make
make install
sudo mkdir -p "/Library/Application Support/OpenSceneGraph/PlugIns"
</PRE></div>
<P>
Open the staging folder you chose for the CMAKE_INSTALL_PREFIX option above.
</P>
<P>
Now move all .frameworks from the lib/ folder in the staging area to /Library/Frameworks. Move the files in the osgPlugins folder in the lib/ folder
to /Library/Application Support/OpenSceneGraph/PlugIns. The bin/ executables
can be left where they are.
</P>
<P>
Next up is <B>libzip</B>. Get the latest tarball at:
</P>
<P>
<A HREF="http://nih.at/libzip/">http://nih.at/libzip/</A>
</P>
<P>
Double-click the source tarball to unpack it.
In a new Terminal cd to the source folder and:
</P>
<div class="code"><PRE>
./configure --disable-dependency-tracking --disable-shared CFLAGS=-Os
make
sudo make install
</PRE></div>
<P>
Then it's time for <B>osgEarth</B>. Downloads are also on github:
</P>
<P>
<A HREF="http://github.com/gwaldron/osgearth/tags">http://github.com/gwaldron/osgearth/tags</A>
</P>
<P>
Download a tarball for the latest stable release (sorting can be confusing here).
Double-click the source tarball to unpack it.
</P>
<P>
<U>Note:</U> for now stick with version 2.3. There are compile errors in 2.4 that need attention.
</P>
<P>
This one also needs an intermediate staging area. Choose a folder similar to OSG.
</P>
<P>
In a new Terminal cd to the source folder and:
</P>
<div class="code"><PRE>
mkdir build
cd build
export PATH="/path/to/osg/staging/folder/bin:$PATH"
cmake -D CMAKE_INSTALL_PREFIX=/path/to/some/staging/folder \
-D CMAKE_BUILD_TYPE=MinSizeRel \
-D OSGEARTH_BUILD_FRAMEWORKS=true \
..
make
make install
sudo mkdir -p "/Library/Application Support/OpenSceneGraph/Headers"
</PRE></div>
<P>
Open the staging folder you chose for the CMAKE_INSTALL_PREFIX option above.
Also open the OSG staging path /bin folder from the OSG build.
</P>
<P>
Move all the .frameworks from the lib/ folder to /Library/Frameworks.
Move the files in the osgPlugins folder in the lib/ folder to
/Library/Application Support/OpenSceneGraph/PlugIns. Move the osgEarthDrivers
folder in the include/ folder to /Library/Application Support/OpenSceneGraph/Headers.
(you may need to create this folder)
And as for OSG, you can leave the bin/ executables where they are.
</P>
<A NAME="toc22"></A>
<H2>5.5. API documentation</H2>
<P>
If you want to build a local copy of the API docs (like those at
<A HREF="http://doc.qgis.org/api">http://doc.qgis.org/api</A>) you will need Graphviz and Doxygen installed:
</P>
<P>
<A HREF="http://www.graphviz.org/Download_macos.php">http://www.graphviz.org/Download_macos.php</A>
</P>
<P>
<A HREF="http://www.stack.nl/~dimitri/doxygen/download.html">http://www.stack.nl/~dimitri/doxygen/download.html</A>
</P>
<P>
Graphviz is simply installed via a regular Mac package installer. Install it
first. It will place some of its binaries in /usr/local/bin/.
</P>
<P>
For Doxygen, compiling the source is recommended over installing the app.
Double-click the source tarball to unpack it, then cd to the source folder and:
</P>
<div class="code"><PRE>
./configure
make -j [#cpus]
sudo make install
</PRE></div>
<P>
The documentation will be output to the build directory, and if using more complete
QGIS.app bundling on install, inside the app in:
</P>
<P>
QGIS.app/Contents/Resources/doc
</P>
<A NAME="toc23"></A>
<H2>5.6. QGIS source</H2>
<P>
Unzip the QGIS source tarball to a working folder of your choice
(/usr/somewhere is not a good choice as it's hidden and requires root
privileges). If you are reading this from the source, you've already done
this.
</P>
<P>
If you want to experiment with the latest development sources, go to the github
QGIS project page:
</P>
<P>
<A HREF="http://github.com/qgis/QGIS">http://github.com/qgis/QGIS</A>
</P>
<P>
It should default to the master branch. Click the <U>Downloads</U> button and
select <U>Download .tar.gz</U>. Double-click the tarball to unzip it.
</P>
<P>
<I>Alternatively</I>, install git from <A HREF="http://git-scm.com">http://git-scm.com</A> and do the following.
</P>
<P>
Make a specific repository directory somewhere, e.g. ~/QGIS/QGIS, and cd
into it. The following will read-only clone the master branch to the directory:
</P>
<div class="code"><PRE>
git init
git remote add -f -t master -m master qgisupstream git://github.com/qgis/QGIS.git
git merge qgisupstream
</PRE></div>
<A NAME="toc24"></A>
<H2>5.7. Configure the build</H2>
<P>
CMake supports out of source build so we will create a 'build' dir for the
build process. OS X uses ${HOME}/Applications as a standard user app folder (it
gives it the system app folder icon). If you have the correct permissions you
may want to build straight into your /Applications folder. The instructions
below assume you are building into a ${HOME}/Applications directory.
</P>
<P>
You have two interactive options for configuring the build: ccmake or run
Terminal commands. ccmake is a curses interface inside Terminal for CMake and
allows a tabular layout for viewing and editing ALL available QGIS source CMake
options. To get started initially run the Terminal method.
</P>
<P>
In a Terminal cd to the qgis source folder previously downloaded, then:
</P>
<div class="code"><PRE>
mkdir build
cd build
cmake -D CMAKE_INSTALL_PREFIX=~/Applications \
-D CMAKE_BUILD_TYPE=MINSIZEREL -D ENABLE_TESTS=FALSE \
-D SPATIALINDEX_LIBRARY=/usr/local/lib/libspatialindex.dylib \
-D SPATIALINDEX_INCLUDE_DIR=/usr/local/include/spatialindex \
-D QWT_LIBRARY=/usr/local/qwt-6.0.2/lib/libqwt.dylib \
-D QWT_INCLUDE_DIR=/usr/local/qwt-6.0.2/include \
-D BISON_EXECUTABLE=/usr/local/bin/bison \
..
</PRE></div>
<P>
<U>Note:</U> Don't forget the .. on the last line, which tells CMake to look for the
source files in one directory up.
</P>
<P>
After the initial Terminal configure, you can use ccmake to make further changes:
</P>
<div class="code"><PRE>
cd build
ccmake ..
</PRE></div>
<P>
This will automatically find and use the previously installed frameworks, and
the GRASS application if installed. Remember to change the Qwt version if a
different version was installed, and possibly paths, e.g. for Qwt 6.0.2 installed
as a framework use:
</P>
<div class="code"><PRE>
-D QWT_LIBRARY=/usr/local/qwt-6.0.2/lib/qwt.framework/qwt \
-D QWT_INCLUDE_DIR=/usr/local/qwt-6.0.2/lib/qwt.framework/Headers \
</PRE></div>
<P>
If you want to use a newer PostgreSQL client than the default Mac OS X version,
e.g. install from kyngchaos.com, set the following option to pg_config's path:
</P>
<div class="code"><PRE>
-D POSTGRES_CONFIG=/usr/local/pgsql/bin/pg_config \
</PRE></div>
<P>
To build a local copy of the API docs (see API documentation section above):
</P>
<div class="code"><PRE>
-D WITH_APIDOC=TRUE \
</PRE></div>
<P>
<U>Snow Leopard note:</U> To handle 32-bit Qt (Carbon), create a 32bit python wrapper
script and add arch flags to the configuration:
</P>
<div class="code"><PRE>
sudo cat &gt;/usr/local/bin/python32 &lt;&lt;EOF
#!/bin/sh
exec arch -i386 /usr/bin/python2.6 \${1+"\$@"}
EOF
sudo chmod +x /usr/local/bin/python32
cmake -D CMAKE_INSTALL_PREFIX=~/Applications \
-D CMAKE_BUILD_TYPE=MINSIZEREL -D ENABLE_TESTS=FALSE \
-D WITH_INTERNAL_SPATIALITE=FALSE -D WITH_PYSPATIALITE=FALSE \
-D SPATIALINDEX_LIBRARY=/usr/local/lib/libspatialindex.dylib \
-D SPATIALINDEX_INCLUDE_DIR=/usr/local/include/spatialindex \
-D QWT_LIBRARY=/usr/local/qwt-5.2.2/lib/libqwt.dylib \
-D QWT_INCLUDE_DIR=/usr/local/qwt-5.2.2/include \
-D BISON_EXECUTABLE=/usr/local/bin/bison \
-D CMAKE_OSX_ARCHITECTURES=i386 -D PYTHON_EXECUTABLE=/usr/local/bin/python32 \
..
</PRE></div>
<P>
<U>Mapserver note:</U> The QGIS Mapserver feature requires fastcgi support. This is included in
Leopard and Snow Leopard, but was dropped at Lion. To build the Mapserver
component on Leopard and Snow, add the following line before the last line in
the above configuration:
</P>
<div class="code"><PRE>
-D WITH_SERVER=TRUE \
</PRE></div>
<P>
On Lion you are on your own to figure out how to install libfcgi and add fcgi
support to the system Apache. Not recommended for the average user.
</P>
<P>
<U>Globe plugin note:</U> If you want the Globe plugin (and you compiled and installed OSG/osgEarth),
add the following lines before the last line in the above configuration:
</P>
<div class="code"><PRE>
-D WITH_GLOBE=true \
-D OSGEARTH_INCLUDE_DIR="/Library/Application Support/OpenSceneGraph/Headers" \
-D OSG_PLUGINS_PATH="/Library/Application Support/OpenSceneGraph/PlugIns" \
</PRE></div>
<P>
<U>Bundling note:</U> Older Qt versions may have problems with some Qt plugins and
QGIS. The way to handle this is to bundle Qt inside the QGIS application. The
default is to bundle Qt (and osg/osgEarth, if configured).
</P>
<P>
Even better for distribution purposes, to also bundle any extra non-framework,
non-standard, libs (ie postgres' libpq) set the bundle value to 2:
</P>
<div class="code"><PRE>
-D QGIS_MACAPP_BUNDLE=2 \
</PRE></div>
<A NAME="toc25"></A>
<H2>5.8. Building</H2>
<P>
Now we can start the build process (remember the parallel compilation note at
the beginning, this is a good place to use it, if you can):
</P>
<div class="code"><PRE>
make -j [#cpus]
</PRE></div>
<P>
If all built without errors you can then install it:
</P>
<div class="code"><PRE>
make install
</PRE></div>
<P>
or, for an /Applications build:
</P>
<div class="code"><PRE>
sudo make install
</PRE></div>
<A NAME="toc26"></A>
<H2>5.9. Post-Install</H2>
<P>
A couple things to take care of.
</P>
<P>
<B>gpsbabel</B>
</P>
<P>
For QGIS to <I>easily</I> find gpsbabel, you need to copy the gpsbabel executable
to the QGIS application. Assuming you installed QGIS in your home folder:
</P>
<div class="code"><PRE>
cp -fp /Applications/GPSBabelFE.app/Contents/MacOS/gpsbabel ~/QGIS.app/Contents/MacOS/bin/
</PRE></div>
<P>
If you installed in /Applications, adjust the path accordingly and prefix the
whole command with 'sudo '.
</P>
<P>
<B>QGIS Server</B>
</P>
<P>
See the QGIS Server documentation page at:
</P>
<P>
<A HREF="http://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/ogc_server_support.html">http://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/ogc_server_support.html</A>
</P>
<P>
for instructions on setting up Apache fastcgi and testing qgis server, including
installing the mod-fastcgi that is missing on Lion.
</P>
<A NAME="toc27"></A>
<H1>6. Setting up the WCS test server on GNU/Linux</H1>
<P>
<B>Requires:</B> Ubuntu / Debian derived distro
</P>
<P>
These notes are for Ubuntu - other versions and Debian derived distros may
require slight variations in package names.
</P>
<A NAME="toc28"></A>
<H2>6.1. Preparation</H2>
<P>
Note the git repo below will change to the default QGIS repo once this work
is integrated into master.
</P>
<P>
git remote add blazek git://github.com/blazek/Quantum-GIS.git
git fetch blazek
git branch --track wcs2 blazek/wcs2
git checkout wcs2
cd /var/www/
sudo mkdir wcs
sudo chown timlinux wcs
cd wcs/
mkdir cgi-bin
cd cgi-bin/
</P>
<A NAME="toc29"></A>
<H2>6.2. Setup mapserver</H2>
<P>
<CODE>`sudo apt-get install cgi-mapserver`</CODE>
</P>
<P>
Set the contents of cgi-bin/wcstest-1.9.0 to:
</P>
<div class="code"><PRE>
#! /bin/sh
MS_MAPFILE=/var/www/wcs/testdata/qgis-1.9.0/raster/wcs.map
export MS_MAPFILE
/usr/lib/cgi-bin/mapserv
</PRE></div>
<P>
Then do:
</P>
<div class="code"><PRE>
chmod +x cgi-bin/wcstest-1.9.0
mkdir -p /var/www/wcs/testdata/qgis-1.9.0/raster/
cd /var/www/wcs/testdata/qgis-1.9.0/raster/
cp -r /home/timlinux/QGIS/tests/testdata/raster/* .
</PRE></div>
<P>
Edit wcs.map and set the shapepath to this:
</P>
<div class="code"><PRE>
SHAPEPATH "/var/www/wcs/testdata/qgis-1.9.0/raster"
</PRE></div>
<P>
Then create /var/www/wcs/7-wcs.qgis.org.conf setting the contents to this:
</P>
<div class="code"><PRE>
&lt;VirtualHost *:80&gt;
ServerName wcs.qgis.org
ServerAdmin tim@linfiniti.com
LogLevel warn
LogFormat "%h %l %u %t \"%r\" %&gt;s %b \"%{Referer}i\" \"%{User-Agent}i\" \"%{forensic-id}n\"" combined
CustomLog /var/log/apache2/wcs_qgis.org/access.log combined
ErrorLog /var/log/apache2/wcs_qgis.org/error.log
DocumentRoot /var/www/wcs/html
ScriptAlias /cgi-bin/ /var/www/wcs/cgi-bin/
&lt;Directory "/var/www/wcs/cgi-bin"&gt;
AllowOverride None
Options +ExecCGI -MultiViews +SymLinksIfOwnerMatch
Order allow,deny
Allow from all
&lt;/Directory&gt;
RewriteEngine on
RewriteRule /1.9.0/wcs /cgi-bin/wcstest-1.9.0 [PT]
&lt;/VirtualHost&gt;
</PRE></div>
<A NAME="toc30"></A>
<H2>6.3. Create a home page</H2>
<div class="code"><PRE>
mkdir html
vim html/index.html
</PRE></div>
<P>
Set the contents to:
</P>
<div class="code"><PRE>
This is the test platform for QGIS' wcs client. You can use these services
from QGIS directly (to try out WCS for example) by pointing your QGIS to:
http://wcs.qgis.org/1.9.0/wcs
</PRE></div>
<A NAME="toc31"></A>
<H2>6.4. Now deploy it</H2>
<div class="code"><PRE>
sudo mkdir /var/log/apache2/wcs_qgis.org
sudo chown www-data /var/log/apache2/wcs_qgis.org
cd /etc/apache2/sites-available/
sudo ln -s /var/www/wcs/7-wcs.qgis.org.conf .
cd /var/www/wcs/
sudo a2ensite 7-wcs.qgis.org.conf
sudo /etc/init.d/apache2 reload
</PRE></div>
<A NAME="toc32"></A>
<H2>6.5. Debugging</H2>
<div class="code"><PRE>
sudo tail -f /var/log/apache2/wcs_qgis.org/error.log
</PRE></div>
<A NAME="toc33"></A>
<H1>7. Setting up a Jenkins Build Server</H1>
<P>
<B>Assumption:</B> You know how to make a working build environment and want to
deploy it under Jenkins for continuous integration testing now.
</P>
<P>
These notes are terse, I will expand on them later as the need arises. The
procedure is:
</P>
<UL>
<LI>Install Jenkins and get it configured according to your own preferences
<LI>Make sure you have the git, github, junit etc plugins installed. A complete
list of the plugins I have installed follows (note that you almost certainly
don't need evey plugin listed here):
<UL>
<LI>External Monitor Job Type Plugin
<LI>LDAP Plugin
<LI>pam-auth
<LI>javadoc
<LI>ant
<LI>Jenkins Subversion Plug-in
<LI>Git Plugin
<LI>Maven 2 Project Plugin
<LI>Jenkins SLOCCount Plug-in
<LI>Jenkins Sounds plugin
<LI>Jenkins Translation Assistance plugin
<LI>ruby-runtime
<LI>Jenkins CVS Plug-in
<LI>Coverage/Complexity Scatter Plot PlugIn
<LI>Status Monitor Plugin
<LI>Git Parameter Plug-In
<LI>github-api
<LI>GitHub plugin
<LI>Jenkins Violations plugin
<LI>git-notes Plugin
<LI>Twitter plugin
<LI>Jenkins Cobertura Plugin
<LI>Jenkins Gravatar plugin
<LI>Jenkins SSH Slaves plugin
</UL>
<LI>Create a Job called 'QGIS'
<LI>Use the following options for your job:
<UL>
<LI>Job Name: QGIS
<LI>Job Type: Build a free-style software project
<LI>Tick enable project based security (you need to elsewhere configure your
Jenkins security to per project settings)
<LI>Allow Anonymous user Read and Discover access
<LI>Set the github project to <A HREF="https://github.com/qgis/QGIS/">https://github.com/qgis/QGIS/</A>
<LI>Set source code management to Git
<LI>Set repository url to git://github.com/qgis/QGIS.git
<LI>In advanced repository url settings set refspec to :
<P></P>
<div class="code"><PRE>
+refs/heads/master:refs/remotes/origin/master
</PRE></div>
<P></P>
<LI>Set branch to build to master
<LI>Repository Browser: Auto
<LI>Build triggers: set to Poll SCM and set schedule to <CODE>* * * * *</CODE> (polls every minute)
<LI>Build - Execute shell and set shell script to:
<P></P>
<div class="code"><PRE>
cd build
cmake ..
xvfb-run --auto-servernum --server-num=1 \
--server-args="-screen 0 1024x768x24" \
make Experimental || true
if [ -f Testing/TAG ] ; then
xsltproc ../tests/ctest2junix.xsl \
Testing/`head -n 1 &lt; Testing/TAG`/Test.xml &gt; \
CTestResults.xml
fi
</PRE></div>
<P></P>
<LI>Add Junit post build action and set 'Publish Junit test result report' to:
<CODE>build/CTestResults.xml</CODE>
<LI>Email notification: Send separate e-mails to individuals who broke the build
<LI>Jenkins sounds - set up sounds for Failure, Success and Unstable.
<LI>Save
</UL>
<P></P>
Now open the Job dash board and push something to QGIS and wait a minute to
validate automated builds work.
<P></P>
<B>Note:</B> You will need to log in to the Jenkins user account and go to
/var/lib/jenkins/jobs/QGIS/workspace, then make a <CODE>build</CODE> directory and run
the initial cmake setup and then do test build. This process is the same as
described elsewhere in this doc.
<P></P>
I based some of the set up from this nice blog article here:
<P></P>
<A HREF="http://alexott.blogspot.com/2012/03/jenkins-cmakectest.html">http://alexott.blogspot.com/2012/03/jenkins-cmakectest.html</A>
</UL>
<A NAME="toc34"></A>
<H1>8. Debug output and running tests</H1>
<P>
If you are interested in seeing embedded debug output, change the following
CMake option:
</P>
<div class="code"><PRE>
-D CMAKE_BUILD_TYPE=DEBUG (or RELWITHDEBINFO)
</PRE></div>
<P>
This will flood your terminal or system log with lots of useful output from
QgsDebugMsg() calls in source code.
</P>
<P>
If you would like to run the test suite, you will need to do so from the build
directory, as it will not work with the installed/bundled app. First set the
CMake option to enable tests:
</P>
<div class="code"><PRE>
-D ENABLE_TESTS=TRUE
</PRE></div>
<P>
Then run all tests from build directory:
</P>
<div class="code"><PRE>
cd build
make test
</PRE></div>
<P>
To run all tests and report to <A HREF="http://dash.orfeo-toolbox.org/index.php?project=QGIS">http://dash.orfeo-toolbox.org/index.php?project=QGIS</A>
</P>
<div class="code"><PRE>
cd build
make Experimental
</PRE></div>
<P>
You can define the host name reported via 'make Experimental' by setting a CMake
option:
</P>
<div class="code"><PRE>
-D SITE="my.domain.org"
</PRE></div>
<P>
To run specific test(s) (see 'man ctest'):
</P>
<div class="code"><PRE>
cd build
# show listing of tests, without running them
ctest --show-only
# run specific C++ or Python test(s) matching a regular expression
ctest --verbose --tests-regex SomeTestName
</PRE></div>
<A NAME="toc35"></A>
<H1>9. Authors and Acknowledgments</H1>
<P>
The following people have contributed to this document:
</P>
<UL>
<LI>Windows MINGW Section
<UL>
<LI>Tim Sutton, Godofredo Contreras 2006
<LI>CMake additions Magnus Homann 2007
<LI>Python additions Martin Dobias 2007
<LI>With thanks to Tisham Dhar for preparing the initial msys environment
<P></P>
</UL>
<LI>Windows MSVC Section (Detailed install)
<UL>
<LI>David Willis 2007
<LI>MSVC install additions Tim Sutton 2007
<LI>PostgreSQL, Qt compile, SIP, Python, AutoExp additions Juergen Fischer 2007
<P></P>
</UL>
<LI>Windows MSVC Section (Simplified install)
<UL>
<LI>Tim Sutton 2007
<LI>Juergen Fischer 2007
<LI>Florian Hillen 2010
<P></P>
</UL>
<LI>OSX Section
<UL>
<LI>Tim Sutton 2007
<LI>With special thanks to Tom Elwertowski and William Kyngesburye
<LI>Larry Shaffer 2012
<P></P>
</UL>
<LI>GNU/Linux Section
<UL>
<LI>Tim Sutton 2006
<LI>Debian package section: Juergen Fischer 2008
<P></P>
</UL>
<LI>WCS Test Server Section
<UL>
<LI>Tim Sutton, Radim Blazek 2012
<P></P>
</UL>
<LI>Jenkins CI Configuration
<UL>
<LI>Tim Sutton 2012
<P></P>
</UL>
<LI>Latex Generator
<UL>
<LI>Tim Sutton 2011
<P></P>
</UL>
<LI>Debug Output/Tests Section
<UL>
<LI>Larry Shaffer 2012, by way of 'Test Friday' Tim Sutton
</UL>
</UL>
</DIV>
<!-- html code generated by txt2tags 2.6 (http://txt2tags.org) -->
<!-- cmdline: txt2tags -\-encoding=utf-8 -o/home/fischer/src/qgis/debian/build-master-qt5/doc/INSTALL.html -t html /home/fischer/src/qgis/doc/INSTALL.t2t -->
</BODY></HTML>